<?php
/*******************************************************************************
* SMF Arcade 2.0.16 (http://www.smfarcade.info)                                *
* Copyright (C) 2004-2009  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* ArcadeInstall.php                                                            *
********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/* This file contains functions and data for installer */

$version = '2.0.16';
$database_version = 3;

$ArcadeSettings = array(
	'gamesPerPage' => array(25, false),
	'scoresPerPage' => array(50, false),
	'gamesDirectory' => array(addslashes($boarddir . '/Games'), false),
	'gamesUrl' => array($boardurl . '/Games', false),
	'arcadeEnabled' => array(true, false),
	'arcadeCheckLevel' => array(1, false),
	'arcadeDefaultCategory' => array(1, false),
	'arcadeGameInformationSide' => array(0, false),
	'arcadeMaxScores' => array(0, false),
	'arcadePermissionMode' => array(1, false),
	'arcadePostPermission' => array(0, false),
	'arcadePostsPlay' => array(0, false),
	'arcadePostsPlayPerDay' => array(0, false),
	// Version
	'arcadeVersion' => array($version, true),
	'arcadeDatabaseVersion' => array($database_version, true),
);

$Permissions = array(
		'arcade_view' => array(-1, 0, 2), // Everyone
		'arcade_play' => array(-1, 0, 2), // Everyone
		'arcade_favorite' => array(0, 2), // Regular members
		'arcade_submit' => array(0, 2), // Regular members
		'arcade_admin' => array(), // Only admins will get this
		'arcade_comment_own' => array(0, 2), // Regular members
		'arcade_comment_any' => array(), // Only admins
		'arcade_rate' => array(0, 2), // Regular members
);

// Table data
$Tables = array(
	'arcade_games' => array(
		'fields' => array(
			'ID_GAME' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'internalName' => 'VARCHAR( 255 ) NOT NULL',
			'gameName' => 'VARCHAR( 255 ) NOT NULL',
			'thumbnail' => 'VARCHAR( 255 ) NOT NULL',
			'thumbnailSmall' => 'VARCHAR( 255 ) NOT NULL',
			'description' => 'TEXT NOT NULL',
			'help' => 'TEXT NOT NULL',
			'ID_CAT' => 'INT unsigned NOT NULL',
			'gameWidth' => 'INT unsigned NOT NULL',
			'gameHeight' => 'INT unsigned NOT NULL',
			'enabled' => 'INT NOT NULL DEFAULT 0',
			'gameFile' => 'VARCHAR( 255 ) NOT NULL',
			'gameDirectory' => 'TINYTEXT NOT NULL',
			'gameType' => 'TINYINT NOT NULL',
			'scoreType' => 'TINYINT NOT NULL',
			'memberGroups' => 'VARCHAR( 255 ) NOT NULL',
			'gameBackgroundColor' => 'VARCHAR( 6 ) NOT NULL',
			'gameRating' => 'TINYINT NOT NULL default 0',
			'ID_MEMBER_CHAMPION' => 'INT unsigned NOT NULL default 0',
			'ID_CHAMPION_SCORE' => 'INT unsigned NOT NULL default 0',
			'gameExtraData' => 'TEXT NOT NULL',
			'numPlays' => 'INT unsigned NOT NULL default 0',
			'numRates' => 'INT unsigned NOT NULL default 0',
			'maxScores' => 'INT NOT NULL default 0',
		),
		'index' => array(
			'ID_GAME' => 'PRIMARY',
			'internalName' => 'unique',
			'gameFile' => 'unique',
		),
	),
	'arcade_personalbest' => array(
		'fields' => array(
			'ID_PB' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'ID_GAME'  => 'INT unsigned NOT NULL',
			'ID_MEMBER'  => 'INT unsigned NOT NULL',
			'score'  => 'FLOAT NOT NULL',
		),
		'index' => array(
			'ID_GAME' => 'index',
			'ID_MEMBER' => 'index',
		),
	),
	'arcade_gameofday' => array(
		'fields' => array(
			'ID_DAY' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'ID_GAME'  => 'INT unsigned NOT NULL',
			'day'  => 'INT unsigned NOT NULL',
		),
		'index' => array(

		),
	),
	'arcade_scores' => array(
		'fields' => array(
			'ID_SCORE' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'ID_GAME'  => 'INT unsigned NOT NULL',
			'ID_MEMBER'  => 'INT unsigned NOT NULL',
			'score'  => 'FLOAT NOT NULL',
			'startTime'  => 'INT unsigned NOT NULL',
			'endTime'  => 'INT unsigned NOT NULL',
			'championFrom'  => 'INT unsigned NOT NULL',
			'championTo'  => 'INT unsigned NOT NULL',
			'position'  => 'INT unsigned NOT NULL',
			'gameDuration'  => 'INT unsigned NOT NULL',
			'memberIp'  => 'VARCHAR( 15 ) NOT NULL',
			'comment'  => 'VARCHAR( 255 ) NOT NULL',
			'scoreStatus'  => 'TINYINT unsigned NOT NULL',
		),
		'index' => array(
			'ID_GAME' => 'index',
			'ID_MEMBER' => 'index',
		),
	),
	'arcade_categories' => array(
		'fields' => array(
			'ID_CAT' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'catName' => 'VARCHAR( 20 ) NOT NULL',
			'numGames' => 'INT unsigned NOT NULL default 0',
			'numPlays' => 'INT unsigned NOT NULL default 0',
			'numRates' => 'INT unsigned NOT NULL default 0',
			'gameRate' => 'INT unsigned NOT NULL default 0',
			'catOrder' => 'INT unsigned NOT NULL default 0',
			'special' => 'INT unsigned NOT NULL default 0',
			'memberGroups' => 'VARCHAR( 255 ) NOT NULL',
		),
		'index' => array(

		),
	),
	'arcade_favorite' => array(
		'fields' => array(
			'ID_FAVORITE' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'ID_MEMBER' => 'INT unsigned NOT NULL',
			'ID_GAME' => 'INT unsigned NOT NULL',
		),
		'index' => array(

		),
	),
	'arcade_rates' => array(
		'fields' => array(
			'ID_RATE' => 'INT unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY',
			'ID_MEMBER' => 'INT unsigned NOT NULL',
			'ID_GAME' => 'INT unsigned NOT NULL',
			'rating' => 'TINYINT unsigned NOT NULL',
			'rateTime' => 'INT unsigned NOT NULL',
		),
		'index' => array(

		),
	),
	/*'arcade_settings' => array(
		'fields' => array(
			'ID_MEMBER' => 'INT unsigned NOT NULL PRIMARY KEY',
			'variable' => 'VARCHAR( 20 )',
			'value' => 'TEXT NOT NULL',
		),
		'index' => array(

		),
	),*/
);

function CreateTables($tables)
{
	//global $db_prefix;

	$errors = array();

	foreach ($tables as $name => $data)
		if (!mysql_query(CreateTable($name, $data)))
			$errors[] = mysql_error();

	return $errors;
}

function CreateTable($name, $data)
{
	global $db_prefix;
	$fields = array();

	foreach ($data['fields'] as $field => $type)
		$fields[] = "`$field` $type";

	foreach ($data['index'] as $key => $type)
	{
		if ($type == 'unique')
			$fields[] = "UNIQUE $key ($key)";
		elseif ($type == 'index')
			$fields[] = "KEY $key ($key)";
	}

	return "CREATE TABLE {$db_prefix}{$name}(" . implode(',', $fields) . ");";
}

function PopulateTables()
{
	global $db_prefix;

	$errors = array();

	$sql[] = "INSERT INTO {$db_prefix}arcade_categories SET catName = 'Default', special = 1, memberGroups = '-1,0,2';";

	foreach ($sql as $query)
		if (!mysql_query($query))
			$errors[] = mysql_error();

	return $errors;
}

function CheckTables($tables)
{
	global $db_prefix;

	 $res = mysql_query('SHOW TABLES');

	 $tables2 = array();

	 while($row = mysql_fetch_array($res))
		foreach($tables as $name)
		{
			if(substr($row[0], -strlen($name)) == $name)
				$tables2[] = $name;
		}

	 $ctab = 0;
	 foreach($tables2 as $name)
		$ctab++;

	 return $ctab;
}

function UpdateTables(&$tables, $full = false)
{
	global $db_prefix;

	$errors = array();

	foreach ($tables as $name => $data)
	{
		$res = mysql_query("DESCRIBE {$db_prefix}{$name}");

		if (!$res)
		{
			$errors[] = mysql_error();

			$sql = CreateTable($name, $data);
			if (!mysql_query($sql))
				$errors[] = mysql_error() . 'Query: <tt>' . $sql . '</tt>';
		}

		else
		{
			while ($field = mysql_fetch_assoc($res))
			{
				if ($full)
				{
					if (isset($data['fields'][ $field['Field'] ]))
					{
						$fname = $field['Field'];
						$type = $data['fields'][ $field['Field'] ];

						$sql = "ALTER TABLE {$db_prefix}{$name} CHANGE $fname $fname $type";

						if (!mysql_query($sql))
							$errors[] = mysql_error() . 'Query: <tt>' . $sql . '</tt>';

					}
					else
					{
						$fname = $field['Field'];
						//$type = $data['fields'][ $field['Field'] ];

						$sql = "ALTER TABLE {$db_prefix}{$name} DROP $fname";

						if (!mysql_query($sql))
							$errors[] = mysql_error() . 'Query: <tt>' . $sql . '</tt>';
					}
				}

				unset($data['fields'][ $field['Field'] ]);
			}

			foreach ($data['fields'] as $field => $type)
			{
				if (!mysql_query("ALTER TABLE {$db_prefix}{$name} ADD $field $type"))
					$errors[] = mysql_error();
			}

			// Now lets check indexes

			if ($full)
			{
				$indexes = mysql_query("SHOW INDEX FROM {$db_prefix}{$name}");

				while ($index = mysql_fetch_assoc($indexes))
				{
					if (!isset($data['index'][$index['Key_name']]))
					{
						if (!mysql_query("ALTER TABLE {$db_prefix}{$name} DROP INDEX $index[Key_name]"))
							$errors[] = mysql_error();
					}
					else
					{
						if ($index['Non_unique'] == 1 && $data['index'][$index['Key_name']] == 'unique')
							if (!mysql_query("ALTER TABLE {$db_prefix}{$name} DROP INDEX $index[Key_name]"))
								$errors[] = mysql_error();
						elseif ($index['Non_unique'] == 0 && $data['index'][$index['Key_name']] != 'unique')
							if (!mysql_query("ALTER TABLE {$db_prefix}{$name} DROP INDEX $index[Key_name]"))
								$errors[] = mysql_error();
						else
							unset($data['index'][$index['Key_name']]);
					}
				}

				foreach ($data['index'] as $name => $type)
				{
					if ($type == 'index')
					{
						if (!mysql_query("ALTER TABLE {$db_prefix}{$name} ADD INDEX ($name)"))
							$errors[] = mysql_error();
					}
					elseif ($type == 'unique')
					{
						if (!mysql_query("ALTER TABLE {$db_prefix}{$name} ADD UNUQUE $name"))
							$errors[] = mysql_error();
					}
				}
			}

		 }
	 }

	 return $errors;
}

function ResetPermissions(&$permissions)
{
	global $db_prefix;

	$errors = array();

	foreach ($permissions as $permission => $groups)
	{
		if (!mysql_query("DELETE FROM {$db_prefix}permissions WHERE permission = '$permission'"))
			$errors[] =  mysql_error();

		foreach ($groups as $ID_GROUP)
		{
			if (!mysql_query("INSERT INTO {$db_prefix}permissions SET ID_GROUP = $ID_GROUP, permission = '$permission'"))
				$errors[] =  mysql_error();
		}
	}

	return $errors;

}

function ResetSettings(&$settings, $update = false)
{
	global $db_prefix;

	$errors = array();

	foreach ($settings as $var => $temp)
	{
		if (!$update || $temp[1] == true)
		{
			if (!mysql_query("REPLACE INTO {$db_prefix}settings SET variable='{$var}', value='{$temp[0]}'"))
				$errors[] = mysql_error();

		}
		else
		{
			$res = mysql_query("SELECT variable FROM {$db_prefix}settings WHERE variable='{$var}'");

			if (!$res)
				$errors[] = mysql_error();

			if (mysql_num_rows($res) == 0)
			{
				if (!mysql_query("INSERT INTO {$db_prefix}settings SET variable='{$var}', value='{$temp[0]}'"))
					$errors[] = mysql_error();

			}
		}

	}

	return $errors;
}

function ImportGames()
{
	global $db_prefix;

	set_time_limit(0);

	$res = mysql_query("SELECT * FROM {$db_prefix}games") or die(mysql_error());

	$games = array();

	while ($game = mysql_fetch_assoc($res))
	{
		$set = array(
			'internalName' => mysql_real_escape_string($game['game']),
			'gameName' => mysql_real_escape_string($game['name']),
			'description' => mysql_real_escape_string($game['dsc']),
			'help' => mysql_real_escape_string($game['help']),
			'ID_CAT' => 1,
			'gameWidth' => $game['width'],
			'gameFile' => $game['file'],
			'gameHeight' => $game['height'],
			'memberGroups' => '-1,0,2',
			'enabled' => 1,
			'gameBackgroundColor' => substr($game['bgcolor'], 1),
		);

		$fields = array();

		foreach($set as $x => $y)
			$fields[] = "$x = '$y'";

		if (!mysql_query("INSERT INTO {$db_prefix}arcade_games SET " . implode(',', $fields)))
			$errors[] = mysql_error();

		$games[$game['game']] = mysql_insert_id();
	}

	mysql_free_result($res);

	$res = mysql_query("SELECT * FROM {$db_prefix}games_high") or die(mysql_error());

	while ($score = mysql_fetch_assoc($res))
		if (!isset($games[$score['game']]))
			echo 'Game not installed: ', $score['game'], ' -> socre not imported<br />';
		else
		{
			$set = array(
				'ID_GAME' => $games[$score['game']],
				'ID_MEMBER' => $score['member'],
				'endTime' => $score['stime'],
				'score' => $score['score'],
				'memberIp' => '0.0.0.0',
				'comment' => mysql_real_escape_string($score['comment']),
				'scoreStatus' => $score['warning'],
				'gameDuration' => $score['duration'],
			);

			$fields = array();

			foreach($set as $x => $y)
				$fields[] = "$x = '$y'";

			if (!mysql_query("INSERT INTO {$db_prefix}arcade_scores SET " . implode(',', $fields)))
				$errors[] = mysql_error();
		}

	mysql_free_result($res);

   return $errors;
}

?>