<?php
/*******************************************************************************
* SMF Arcade 2.0.14 (http://www.smfarcade.info)                                *
* Copyright (C) 2004-2009  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* ArcadeList.php                                                               *
********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/*	This file handles Arcade and loads required files.

	void ArcadeList()
		- ???

	void ArcadeRate()
		- ???

	void ArcadeFavorite()
		- ???

	void ArcadeSearch()
		- ???

	void ArcadeSearchXML()
		- ???

*/

function ArcadeList()
{
 	global $scripturl, $txt, $db_prefix, $modSettings, $context, $user_info, $ID_MEMBER;

	// How many games per page?
	$gamesPerPage = isset($modSettings['gamesPerPage']) ? $modSettings['gamesPerPage'] : 25;
	$_REQUEST['start'] = (int) $_REQUEST['start'];

	$where = "enabled = 1 AND $user_info[query_see_game]";

	$search = false;
	$favorite = false;

	if (isset($_REQUEST['category']))
	{
		$search = true;
		$category = (int) $_REQUEST['category'];
		$where .= " AND game.ID_CAT= $category";
	}

	if (isset($_REQUEST['name']))
	{
		$search = true;
		$name = $_REQUEST['name'];
		$where .= " AND game.gameName LIKE '%$name%'";
	}

	if (isset($_REQUEST['favorites']))
	{
		$search = true;
		$favorite = true;
		$favorite_join = "INNER JOIN";
	}
	else
		$favorite_join = "LEFT JOIN";

	// How many games there are
	if ($favorite)
		$result_count = db_query("
			SELECT count(*) AS gc
			FROM ({$db_prefix}arcade_games AS game, {$db_prefix}arcade_favorite AS favorite)
				LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
			WHERE favorite.ID_GAME = game.ID_GAME
				AND favorite.ID_MEMBER = $ID_MEMBER
				AND $where", __FILE__, __LINE__);

	else
		$result_count = db_query("
			SELECT count(*) AS gc
			FROM {$db_prefix}arcade_games AS game
			LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
			WHERE $where", __FILE__, __LINE__);


	$gameCount = mysql_fetch_assoc($result_count);
	mysql_free_result($result_count);

	$parts = array(
		$scripturl . '?action=arcade'
	);

	// Sorting methods
	$sort_methods = array(
		'name' => 'game.gameName',
		'plays' => 'game.numPlays',
		'champion' => 'IFNULL(mem.realName, mem.memberName)',
		'myscore' => 'IFNULL(pb.score, 0)',
		'category' => 'category.catName',
		'favorite' => 'IF(favorite.ID_FAVORITE = null, 0, 1)'
	);

	// How user wants to sort games?
	if (!isset($_REQUEST['sort']) || !isset($sort_methods[$_REQUEST['sort']]))
	{
		$context['sort_by'] = 'name';
		$_REQUEST['sort'] = 'game.gameName';
	}
	else
	{
		$context['sort_by'] = $_REQUEST['sort'];
		$_REQUEST['sort'] = $sort_methods[$_REQUEST['sort']];

		$parts[] = 'sort=' . $context['sort_by'];
	}

	$ascending = !isset($_REQUEST['desc']);
	$context['sort_direction'] = $ascending ? 'up' : 'down';

	if (!$ascending)
		$parts[] = 'desc';

	if ($search)
	{
		if (isset($category))
			$parts[] = 'category=' . $category;

		if (isset($name))
			$parts[] = 'name=' . urlencode($name);

		if (!empty($favorite))
			$parts[] = 'favorites';
	}

	$context['arcade']['pageIndex'] = constructPageIndex(implode(';', $parts) , $_REQUEST['start'], $gameCount['gc'] , $gamesPerPage, false );

	$result_games = db_query("
		SELECT
			game.ID_GAME, game.gameName, game.description, game.gameRating, game.numPlays, game.gameFile,
			game.gameDirectory, game.gameType, game.internalName, game.gameWidth, game.gameHeight,
			game.gameBackgroundColor AS bgcolor, game.scoreType, game.maxScores,game.thumbnail,
			game.thumbnailSmall, game.help, IFNULL(score.ID_SCORE,0) AS ID_SCORE, IFNULL(score.score,0) AS champScore,
			IFNULL(score.endTime, 0) AS champTime, IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER, IFNULL(mem.realName, '') AS realName,
			IFNULL(score.endTime, 0) AS championTime, IFNULL(favorite.ID_FAVORITE, 0) AS isFavorite, IFNULL(category.ID_CAT, 0) AS ID_CAT,
			IFNULL(category.catName, '') As catName, IFNULL(pb.ID_PB, 0) AS ID_PB, IFNULL(pb.score, 0) AS personalBest
		FROM {$db_prefix}arcade_games as game
			$favorite_join {$db_prefix}arcade_favorite AS favorite ON (favorite.ID_GAME = game.ID_GAME AND favorite.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}arcade_scores AS score ON (score.ID_SCORE = game.ID_CHAMPION_SCORE)
			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = game.ID_MEMBER_CHAMPION)
			LEFT JOIN {$db_prefix}arcade_personalbest AS pb ON (pb.ID_GAME = game.ID_GAME AND pb.ID_MEMBER = $ID_MEMBER)
			LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
		WHERE $where
		ORDER BY $_REQUEST[sort]" . ($ascending ? '' : ' DESC') . "
		LIMIT $_REQUEST[start], $gamesPerPage", __FILE__, __LINE__);

	$context['arcade']['games'] = array();
	$context['arcade']['search'] = $search;


	while ($game = mysql_fetch_assoc($result_games))
	{
		if ($gameCount['gc'] == 1 && $search && !$favorite) // Redirect to game if only one result in search and not favorites search
			redirectexit('action=arcade;sa=play;game=' . $game['ID_GAME']);

		$context['arcade']['games'][] = BuildGameArray($game);
	}

	// Free results since we don't want to use too much memory
	mysql_free_result($result_games);

	$context['sub_template'] = 'arcade_list';
	$context['page_title'] = $txt['arcade_game_list'];
}

function ArcadeRate()
{
	global $txt, $db_prefix, $modSettings, $context, $user_info, $ID_MEMBER;

	$xml = isset($_REQUEST['xml']);
	$game = ArcadeGameInfo((int) $_REQUEST['game']); // Get game info

	if ($game === false)
		fatal_lang_error('arcade_game_not_found'); // Game was not found

	$rate = (int) $_REQUEST['rate'];
	if ($rate < 0 || $rate > 5)
		fatal_lang_error('arcade_rate_error');  // Don't allow invalid rates

	// We may need time ;)
	$time = time();

	// To ensure there will be no doubles
	db_query("
		DELETE FROM {$db_prefix}arcade_rates
		WHERE ID_MEMBER = $ID_MEMBER AND ID_GAME = $game[id]", __FILE__ ,__LINE__);
	// Insert rating

	if ($rate > 0)
	{
		db_query("
			INSERT INTO {$db_prefix}arcade_rates
			SET ID_MEMBER = $ID_MEMBER, ID_GAME = $game[id], rating = $rate, rateTime = $time", __FILE__ ,__LINE__);
	}

	// Update rating
	$res = db_query("
		SELECT SUM(rating) AS rating, COUNT(rating) AS rates
		FROM {$db_prefix}arcade_rates
		WHERE ID_GAME = $game[id]
		GROUP BY ID_GAME", __FILE__ ,__LINE__);
	$new_rating = mysql_fetch_assoc($res);
	$rate2 = $new_rating['rating'] / $new_rating['rates'];
	UpdateGame($game['id'], array('gameRating' => $rate2));

   	if (!$xml)
   	{
		// Go to reffering page (or highscore page)
		if (!isset($_SERVER['HTTP_REFERER']) || $_SERVER['HTTP_REFERER'] == '')
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		else
			redirectexit($_SERVER['HTTP_REFERER']);
	}
	else
	{
   		   $context['sub_template'] = 'xml';
   		   $context['arcade']['message'] = 'arcade_rating_saved';
   		   $context['arcade']['extra'] = '<rating>' . floor($rate2) . '</rating>';
	}
}

function ArcadeFavorite()
{
	global $txt, $db_prefix, $modSettings, $context, $user_info, $ID_MEMBER;

	$xml = isset($_REQUEST['xml']) ? true : false;

	if ($user_info['is_guest'])
		fatal_lang_error('arcade_not_for_guest');

   	$game = ArcadeGameInfo((int) $_REQUEST['game']);

	if ($game === false)
		fatal_lang_error('arcade_game_not_found'); // Game was not found

	// It's favorite so we can remove it
	if ($game['isFavorite'])
	{
		$remove = true;

		db_query("
			DELETE FROM {$db_prefix}arcade_favorite
			WHERE ID_MEMBER = $ID_MEMBER AND ID_GAME = $game[id]",__FILE__,__LINE__);
	}
	// It's not favorite, let's add it
	else
	{
		$remove = false;

		db_query("
			INSERT INTO {$db_prefix}arcade_favorite
			SET ID_MEMBER = $ID_MEMBER, ID_GAME = $game[id]",__FILE__,__LINE__);
	}

	if (!$xml)
	{
		if (!isset($_SERVER['HTTP_REFERER']) || $_SERVER['HTTP_REFERER'] == '')
			redirectexit('?action=arcade');
		else
			redirectexit($_SERVER['HTTP_REFERER']);
	}

	else
	{
		$state = $remove ? 0 : 1;
		$context['sub_template'] = 'xml';
   		$context['arcade']['message'] = $remove ? 'arcade_favorite_removed' : 'arcade_favorite_added';
   		$context['arcade']['extra'] = '<state>' . $state . '</state>';
	}
}

function ArcadeSearch()
{
	// global $scripturl, $txt, $db_prefix, $modSettings, $context, $settings, $options, $sourcedir, $user_info, $ID_MEMBER;

	if (isset($_REQUEST['xml']))
		ArcadeSearchXML();
}


function ArcadeSearchXML()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $user_info, $ID_MEMBER;

	if (!isset($_REQUEST['name']))
		redirectexit('action=arcade');

	$limit = 5;

	$search = mysql_real_escape_string($_REQUEST['name']);

	$result_count = db_query("
		SELECT count(*) AS games
		FROM  {$db_prefix}arcade_games as game
			LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
		WHERE game.gameName LIKE '%$search%' AND $user_info[query_see_game]
		ORDER BY gameName", __FILE__, __LINE__);

	$how_many = mysql_fetch_assoc($result_count);

	mysql_free_result($result_count);

	$result_games = db_query("
		SELECT
			game.ID_GAME, game.gameName
		FROM  {$db_prefix}arcade_games AS game
			LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
		WHERE game.gameName LIKE '%$search%' AND $user_info[query_see_game]
		ORDER BY gameName
		LIMIT 0, $limit", __FILE__, __LINE__);

	$context['arcade']['search'] = array();
	$context['arcade']['search']['games'] = array();
	$context['arcade']['search']['more'] = $how_many['games'] > $limit ? 1 : 0;
	$context['arcade']['search']['more_url'] = $scripturl . '?action=arcade;name=' . urlencode($_REQUEST['name']);

	while ($game = mysql_fetch_assoc($result_games))
		$context['arcade']['search']['games'][] = array(
			'name' => $game['gameName'],
			'id' => $game['ID_GAME'],
			'url' => $scripturl . '?action=arcade;game=' . $game['ID_GAME']
		);

	mysql_free_result($result_games);

	$context['sub_template'] = 'xml_list';
}

?>