<?php
/*******************************************************************************
* SMF Arcade 2.0.14 (http://www.smfarcade.info)                                *
* Copyright (C) 2004-2007  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* ArcadePlay.php                                                               *
********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/*
	void ArcadePlay()
		- ...

	void ArcadeComment()
		- ...

	void ArcadeHighscore()
		- ...

	void ArcadeSubmit()
		- Handles score submits

	void ArcadeSubmitIBP()
		- ...

	void ArcadeVerifyIBP()
		- ...

	boolean CheatingCheck(&allowFail, &checkPassed)
		- Does basic cheating check

	void ClearSession(&game)
		- ...

*/

function ArcadePlay()
{
 	global $scripturl, $txt, $db_prefix, $context;

 	if (!$context['arcade']['can_play'])
 		fatal_lang_error('cannot_arcade_play');

	$xml = isset($_REQUEST['xml']);

	if (isset($_REQUEST['random']) && !isset($_REQUEST['game']) && !$xml) // Get random game if it is requested and there isn't game set
		$id = 0;

	elseif (!empty($_REQUEST['game']))
		$id = (int) $_REQUEST['game'];

	else
		fatal_lang_error('arcade_game_not_found');

	$game = ArcadeGameInfo($id); // Fetch gameinfo from database (function defined in Arcademain.php)

	// Was game found
	if ($game == false)
		fatal_lang_error('arcade_game_not_found');

	if (isset($_REQUEST['delete']))
	{
		checkSession('get');
		unset($_SESSION['arcade']['play'][$game['internalName']]);
		unset($_SESSION['arcade']['ibp']['game']);
	}

	if ($xml)
	{
		// XML request

		$context['sub_template'] = 'xml';
		$context['arcade']['message'] = 'arcade_session_check_ok';

		$_SESSION['arcade']['play'][$game['internalName']] = array(
			'game' => $game['internalName'],
			'id' => $game['id'],
			'startTime' => time(),
			'done' => false,
			'score' => 0,
			'endTime' => 0,
		);

		$_SESSION['arcade']['ibp']['game'] = $game['id'];

		// Increase plays by one (this is done here because xml request is sent even on first play so it won't be counted as two plays)
		db_query("
			UPDATE {$db_prefix}arcade_games
			SET numPlays = numPlays + 1
			WHERE ID_GAME = $game[id]", __FILE__, __LINE__);

		return true;
	}

	$message = $txt['arcade_no_javascript'];

	$context['arcade']['game'] = &$game;

	// Generate html-code for game
	if ($game['gameType'] == 0)
		$context['arcade']['game']['html'] = ArcadeFlashHtml($game, true, $message);

	// Layout start
	$context['template_layers'][] = 'ArcadeGame';
	$context['sub_template'] = 'arcade_game_play';
	$context['page_title'] = $txt['arcade_game_play'];
	$context['arcade']['play'] = true;

	$context['arcade']['menu'][] = array(
		'data' => array(),
		'template' => 'ArcadeMenu_GameInformation'
	);
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=arcade;sa=play;game=' . $game['id'],
		'name' => $game['name'],
	);

	// We store this session to check cheating later
	$_SESSION['arcade']['play'][$game['internalName']] = array(
		'game' => $context['arcade']['game']['internalName'],
		'id' => $context['arcade']['game']['id'],
		'startTime' => time(),
		'done' => false,
		'score' => 0,
		'endTime' => 0,
	);

	$_SESSION['arcade']['ibp']['game'] = $game['id'];
}

function ArcadeComment()
{
	global $scripturl, $txt, $db_prefix, $context, $ID_MEMBER, $sourcedir;
	global $func;

	$xml = isset($_REQUEST['xml']);

	if ($context['arcade']['can_comment_any'] || $context['arcade']['can_comment_own'])
		$any = $context['arcade']['can_comment_any'];

	else
	{
		// Normal mode
		if (!$xml)
			fatal_lang_error('cannot_arcade_comment_own');
		// Ajax
		else
		{
			$context['sub_template'] = 'xml';
			$context['arcade']['message'] = 'cannot_arcade_comment_own';

			return false;
		}
	}

	if ($any)
		$where = '1';
	else
		$where = "ID_MEMBER = $ID_MEMBER";

	require_once($sourcedir . '/Subs-Post.php');

	$comment = strtr($func['htmlspecialchars'](stripslashes($_REQUEST['comment']), ENT_QUOTES), array("\r" => '', "\n" => '', "\t" => ''));
	preparsecode($comment);
	$ecomment = addslashes($comment);

	$score = (int) $_REQUEST['score'];

	db_query("
		UPDATE {$db_prefix}arcade_scores
		SET comment = '$ecomment'
		WHERE ID_SCORE = $score AND $where", __FILE__, __LINE__);

	$_SESSION['arcade']['highscore']['saved'] = true;

	if ($xml)
	{
		$context['sub_template'] = 'xml';
		$context['arcade']['message'] = parse_bbc($comment);
	}
	else
		redirectexit('action=arcade;sa=highscore;game=' . (int) $_REQUEST['game']);

}

function ArcadeHighscore()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $ID_MEMBER;

	// Is game set
	if (!isset($_REQUEST['game']))
		fatal_lang_error('arcade_game_not_found');

	// Get game info
	$game = ArcadeGameInfo((int) $_REQUEST['game']);

	if ($game === false || !$game['highscoreSupport'])
		fatal_lang_error('arcade_game_not_found'); // Game was not found

	$context['arcade']['menu']['game_information'] = array(
		'data' => array(),
		'template' => 'ArcadeMenu_GameInformation'
	);

	// Do we show remove score functions?
	$context['arcade']['show_editor'] = $context['arcade']['can_admin'];

	// Do we have scores to delete?
	if ($context['arcade']['can_admin'] && isset($_REQUEST['delete']))
	{
		checkSession('request');

		$_REQUEST['score'] = (int) $_REQUEST['score'];

		db_query("
			DELETE FROM {$db_prefix}arcade_scores
			WHERE ID_SCORE = $_REQUEST[score]", __FILE__, __LINE__);

		ArcadeFixPositions($game['id']);
	}

	$context['template_layers'][] = 'ArcadeGame';
	$context['sub_template'] = 'arcade_game_highscore';
	$context['page_title'] = $txt['arcade_view_highscore'];

	// We don't play :)
	$context['arcade']['play'] = false;

	$context['linktree'][] = array(
		'url' => $scripturl . '?action=arcade;sa=play;game=' . $game['id'],
		'name' => $game['name'],
	);
	$context['linktree'][] = array(
		'url' => $scripturl . '?action=arcade;sa=highscore;game=' . $game['id'],
		'name' => $txt['arcade_viewscore'],
	);

	$scoresPerPage = isset($modSettings['scoresPerPage']) ? $modSettings['scoresPerPage'] : 50;

	// Did we just play
	if (isset($_SESSION['arcade']['highscore']))
	{
		if ($_SESSION['arcade']['highscore']['gameid'] == $game['id'])
		{
			// For highlight
			$newScore = $_SESSION['arcade']['highscore']['saved'];
			$newScore_id = $_SESSION['arcade']['highscore']['id'];

			$context['arcade']['new_score'] = array(
				'id' => $_SESSION['arcade']['highscore']['id'],
				'saved' => $_SESSION['arcade']['highscore']['saved'],
				'error' => isset($_SESSION['arcade']['highscore']['error']) ? $_SESSION['arcade']['highscore']['error'] : '',
				'score' => comma_format($_SESSION['arcade']['highscore']['score']),
				'position' => $_SESSION['arcade']['highscore']['position'],
				'can_comment' => $context['arcade']['can_comment_own'] || $context['arcade']['can_comment_any'],
				'is_new_champion' => isset($_SESSION['arcade']['highscore']['champion']) ? $_SESSION['arcade']['highscore']['champion'] : false,
				'is_personal_best' => isset($_SESSION['arcade']['highscore']['best']) ? $_SESSION['arcade']['highscore']['best'] : false,
			);


			if (!isset($_GET['start']) && !isset($_POST['start']))
				$_REQUEST['start'] = $_SESSION['arcade']['highscore']['start'];
		}
		else
		{
			$newScore = false;
			unset($_SESSION['arcade']['highscore']);
		}
	}
	else
		$newScore = false;

	// How many scores there are
	$result_count = db_query("
		SELECT count(*) AS sc
		FROM  {$db_prefix}arcade_scores
		WHERE ID_GAME = $game[id]", __FILE__, __LINE__);

	$score_sort = $game['scoreType'] == 0 ? 'DESC' : 'ASC';

	// Actual query
	$result_scores = db_query("
		SELECT
			a.ID_SCORE, a.score, a.endTime AS time, a.gameDuration AS duration, a.comment,
			a.position, a.scoreStatus, IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER, IFNULL(mem.realName, '') AS realName
		FROM  {$db_prefix}arcade_scores AS a
		LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = a.ID_MEMBER)
		WHERE ID_GAME = $game[id]
		ORDER BY position
		LIMIT $_REQUEST[start], $scoresPerPage", __FILE__, __LINE__);

	$context['arcade']['scores'] = array();
	$context['arcade']['game']	= $game;

	while ($score = mysql_fetch_assoc($result_scores))
	{
		censorText($score['comment']);
		$own = $ID_MEMBER == $score['ID_MEMBER'];

		$context['arcade']['scores'][] = array(
			'id' => $score['ID_SCORE'],
			'own' => $own,
			'memberLink' => !empty($score['realName']) ? '<a href="' . $scripturl . '?action=profile;u=' . $score['ID_MEMBER'] . '">' . $score['realName'] . '</a>' : $txt['arcade_guest'],
			'score' => comma_format($score['score']),
			'time' => timeformat($score['time']),
			'duration' => $score['duration'],
			'position' => $score['position'],
			'score_status' => $score['scoreStatus'],
			'comment' => parse_bbc(!empty($score['comment']) ? $score['comment'] : $txt['arcade_no_comment']),
			'raw_comment' => $score['comment'],
			'highlight' => $newScore ? $score['ID_SCORE'] == $newScore_id : false,
			'can_edit' =>  $newScore ? false : ($own ? ($context['arcade']['can_comment_own'] || $context['arcade']['can_comment_any']) : $context['arcade']['can_comment_any']),
			'edit' => isset($_REQUEST['edit']) && isset($_REQUEST['score']) && (int) $_REQUEST['score'] == $score['ID_SCORE'],
		);
	}

	$scoreCount = mysql_fetch_assoc($result_count);

	// Free results since we don't want to use too much memory
	mysql_free_result($result_scores);
	mysql_free_result($result_count);

	$context['arcade']['pageIndex'] = constructPageIndex($scripturl . '?action=arcade;sa=highscore;game=' . $game['id'], $_REQUEST['start'], $scoreCount['sc'] , $scoresPerPage, false );
}

function CheatingCheck(&$allowFail, &$checkPassed)
{
	global $scripturl, $modSettings;

	// Default check level is 1
	if (!isset($modSettings['arcadeCheckLevel']))
		$modSettings['arcadeCheckLevel'] = 1;

	if (!empty($_SERVER['HTTP_REFERER']))
		$referer = parse_url($_SERVER['HTTP_REFERER']);

	$real = parse_url($scripturl);

	// Level 1 Check
	// Checks also HTTP_REFERER if it not is empty
	if ($modSettings['arcadeCheckLevel'] == 1)
	{
		if (isset($referer) && $real['host'] == $referer['host'] && $real['scheme'] == $referer['scheme'])
			$checkPassed = true;
		elseif (isset($referer))
			$checkPassed = false;
		else
			$checkPassed = true;
	}
	// Level 2 Check
	// Doesn't allow HTTP_REFERER to be empty
	elseif ($modSettings['arcadeCheckLevel'] == 2)
	{
		if (isset($referer) && $real['host'] == $referer['host'] && $real['scheme'] == $referer['scheme'])
			$checkPassed = true;
		else
			$checkPassed = false;
	}
	// Level 0 check
	else
	{
		$checkPassed = true;
		$allowFail = true;
	}

	if ($allowFail || $checkPassed)
		return true;
	else
		return false;
}

function ArcadeSubmit()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context;

	// Has game session been started, if not then it's probably cheater
	if (isset($_SESSION['arcade']['play'][$_POST['game']]))
	{
		$session_info = &$_SESSION['arcade']['play'][ $_POST['game'] ];
		$game = ArcadeGameInfo(0, $session_info['game']);
		// Is game installed
		if ($game === false)
		{
			// Not needed anymore
			unset($session_info);
			fatal_lang_error('arcade_game_not_found');
		}

		// Was score even submitted
		if (isset($_POST['score']) && is_numeric($_POST['score']))
			$score = (float) $_POST['score'];

		else
		{
			ClearSession($game);
			fatal_lang_error('arcade_submit_error');
		}

		// Preset these
		$checkPassed = false;
		$allowFail = false;

		if (!CheatingCheck($allowFail, $checkPassed))
		{
			ClearSession($game);
			fatal_lang_error('arcade_submit_error_check_failed');
		}

		if  (allowedTo('arcade_submit'))
		{
			// Save score
			$start = $session_info['startTime'];
			$save = ArcadeSaveScore($game, $score, $start, time(), $checkPassed);
			ClearSession($game);

			// Saving failed
			if ($save === false || $save['ID_SCORE'] === false)
				$_SESSION['arcade']['highscore'] = array(
					'id' => false,
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => 0,
					'start' => 0,
					'saved' => false,
					'error' => isset($save['error']) ? $save['error'] : 'arcade_no_permission'
				);

			// Save succesful
			else
				$_SESSION['arcade']['highscore'] = array(
					'id' => $save['ID_SCORE'],
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => $save['position'],
					'start' => $save['start'],
					'champion' => $save['new_champion'],
					'best' => $save['ownbest'],
					'saved' => true,
				);

			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}
		else
		{
			// Too bad no permission to submit score, this isn't fun :(
			$_SESSION['arcade']['highscore'] = array(
				'id' => false,
				'game' => $game['internalName'],
				'score' => $score,
				'gameid' => $game['id'],
				'position' => 0,
				'start' => 0,
				'saved' => false,
				'error' => 'arcade_no_permission',
			);

			// Not needed anymore
			ClearSession($game);

			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}
	}
	elseif (isset($_SESSION['arcade']['highscore']))
		redirectexit('action=arcade;sa=highscore;game=' . $_SESSION['arcade']['highscore']['gameid']);

	else
		fatal_lang_error('arcade_submit_error_session');
}

function ArcadeSubmitIBP()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context;

	if (isset($_SESSION['arcade']['ibp']) && isset($_REQUEST['ibpa']) && $_REQUEST['ibpa'] == 3)
	{
		$game = ArcadeGameInfo($_SESSION['arcade']['ibp']['game']);
		if ($game === false)
			fatal_lang_error('arcade_game_not_found');

		$session_info = &$_SESSION['arcade']['play'][$game['internalName']];
		$time_taken = microtime_float() - $_SESSION['arcade']['ibp']['verify'][2];

		if ($time_taken < 0 || $time_taken > 7)
			fatal_lang_error('arcade_submit_error_session');

		// Was score even submitted
		if (isset($_POST['gscore']) && is_numeric($_POST['gscore']))
			$score = (float) $_POST['gscore'];

		else
		{
			unset($session_info); // Not needed anymore
			fatal_lang_error('arcade_submit_error');
		}

		$score_check = $score * $_SESSION['arcade']['ibp']['verify'][0] ^ $_SESSION['arcade']['ibp']['verify'][1];
		$score_check2 = $_POST['enscore'];

		if ($score_check != $score_check2)
			fatal_lang_error('arcade_submit_error_session');

		if  (allowedTo('arcade_submit'))
		{
			$save = ArcadeSaveScore($game, $score, $session_info['startTime'], round($_SESSION['arcade']['ibp']['verify'][2], 0), true);
			ClearSession($game);

			if ($save === false || $save['ID_SCORE'] === false)
				$_SESSION['arcade']['highscore'] = array(
					'id' => false,
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => 0,
					'start' => 0,
					'saved' => false,
					'error' => isset($save['error']) ? $save['error'] : 'arcade_no_permission'
				);

			// Save succesful
			else
				$_SESSION['arcade']['highscore'] = array(
					'id' => $save['ID_SCORE'],
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => $save['position'],
					'start' => $save['start'],
					'champion' => $save['new_champion'],
					'best' => $save['ownbest'],
					'saved' => true,
				);

			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}
		else
		{
			// Too bad no permission to submit score, this isn't fun :(
			$_SESSION['arcade']['highscore'] = array(
				'id' => false,
				'game' => $game['internalName'],
				'score' => $score,
				'gameid' => $game['id'],
				'position' => 0,
				'start' => 0,
				'saved' => false,
				'error' => 'arcade_no_permission'
			);

			ClearSession($game);

			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}
	}
	elseif (isset($_REQUEST['ibpa']) && $_REQUEST['ibpa'] == 2)
	{
		$game = ArcadeGameInfo(null, $_POST['gname']);
		if ($game === false)
			fatal_lang_error('arcade_game_not_found');

		// Was score even submitted
		if (isset($_POST['gscore']) && is_numeric($_POST['gscore']))
			$score = (float) $_POST['gscore'];

		else
		{
			ClearSession($game);
			fatal_lang_error('arcade_submit_error');
		}

		$session_info = &$_SESSION['arcade']['play'][$game['internalName']];

		// Preset these
		$checkPassed = false;
		$allowFail = false;

		if (!CheatingCheck($allowFail, $checkPassed))
		{
			ClearSession($game);
			fatal_lang_error('arcade_submit_error_check_failed');
		}

		if  (allowedTo('arcade_submit'))
		{
			$save = ArcadeSaveScore($game, $score, $session_info['startTime'], time(), true);
			ClearSession($game);

			if ($save === false || $save['ID_SCORE'] === false)
				$_SESSION['arcade']['highscore'] = array(
					'id' => false,
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => 0,
					'start' => 0,
					'saved' => false,
					'error' => isset($save['error']) ? $save['error'] : 'arcade_no_permission'
				);

			// Save succesful
			else
				$_SESSION['arcade']['highscore'] = array(
					'id' => $save['ID_SCORE'],
					'game' => $game['internalName'],
					'score' => $score,
					'gameid' => $game['id'],
					'position' => $save['position'],
					'start' => $save['start'],
					'champion' => $save['new_champion'],
					'best' => $save['ownbest'],
					'saved' => true,
				);

			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}
		else
		{
			// Too bad no permission to submit score, this isn't fun :(
			$_SESSION['arcade']['highscore'] = array(
				'id' => false,
				'game' => $game['internalName'],
				'score' => $score,
				'gameid' => $game['id'],
				'position' => 0,
				'start' => 0,
				'saved' => false,
				'error' => 'arcade_no_permission'
			);

			ClearSession($game);
			// Go to scores list
			redirectexit('action=arcade;sa=highscore;game=' . $game['id']);
		}

	}
	else
		fatal_lang_error('arcade_submit_error_session');

}

function ClearSession(&$game)
{
	global $context;

	unset($_SESSION['arcade']['play'][$game['internalName']]);

	if (isset($_SESSION['arcade']['ibp']) && $_SESSION['arcade']['ibp']['game'] == $game['id'])
		unset($_SESSION['arcade']['ibp']);
}

function ArcadeVerifyIBP()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context;

	$randomchar = rand(1, 200);
	$randomchar2 = rand(1, 200);

	$_SESSION['arcade']['ibp']['verify'] = array($randomchar, $randomchar2, microtime_float());

	// We output flash vars no need for anything that might output something before or after this
	ob_end_clean();
	if (!empty($modSettings['enableCompressedOutput']))
		@ob_start('ob_gzhandler');
	else
		ob_start();

	echo '&randchar=', $randomchar, '&randchar2=', $randomchar2, '&savescore=1&blah=OK';

	obExit(false);
}
?>