<?php
/*******************************************************************************
* SMF Arcade 2.0.8 (http://www.smfarcade.info)                                 *
* Copyright (C) 2004-2007  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* ManageGames.php                                                              *
********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

/*	Game editor, install, remove

	void GamesAdmin()
		- Main function calls others depending on subaction

	void prepareEditor()
		- ???

	void GamesAdminEditor()
		- Shows editor screeen

	void GamesAdminEditor2()
		- Saves
		- Displays again if theres errors

	void GamesAdminList()
		- List games that is installed

	void GamesAdminFiles()
		- List files that maybe installed

	void GameAdminInstall()
		- ...

	void GamesAdminInstall2()
		- ...

	void GamesDelete()
		- Removes game and scores from database

	array createGame(game)
		- Insert game to database based on data given
		- Returns array of strings

*/

function GamesAdmin()
{
	global $scripturl, $txt, $context, $sourcedir;

	require_once($sourcedir . '/Arcade.php');

	// Templates
	loadTemplate('ManageGames');
	ArcadeLoad('admin', 'manage_games');

	$subActions = array(
		'edit' => array('GamesAdminEditor', 'arcade_admin'),
		'edit2' => array('GamesAdminEditor2', 'arcade_admin'),
		'quick' => array('GamesQuickEdit', 'arcade_admin'),
		'list' => array('GamesAdminList', 'arcade_admin'),
		'files' => array('GamesAdminFiles', 'arcade_admin'),
		'install' => array('GamesAdminInstall', 'arcade_admin'),
		'install2' => array('GamesAdminInstall2', 'arcade_admin'),
		'delete' => array('GamesDelete', 'arcade_admin'),
		'upload' => array('GamesUpload', 'arcade_admin'),
		'highscore' => array('HighscoreEditor', 'arcade_admin'),
		'highscore2' => array('HighscoreEditor2', 'arcade_admin'),
	);

	// What user wants to do?
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'list';
	// Do we have reason to allow him/her to do it?
	isAllowedTo($subActions[$_REQUEST['sa']][1]);

	// Create the tabs for the template.
	$context['admin_tabs'] = array(
		'title' => $txt['arcade_manage_games'],
		'help' => 'manage_games',
		'description' => '',
		'tabs' => array(),
	);

	$context['admin_tabs']['tabs']['index'] = array(
		'title' => $txt['arcade_games'],
		'description' => '',
		'href' => $scripturl . '?action=managegames',
		'is_selected' => in_array($_REQUEST['sa'], array('list', 'edit', 'edit2')),
	);

	$context['admin_tabs']['tabs']['install'] = array(
		'title' => $txt['arcade_install_game'],
		'description' => '',
		'href' => $scripturl . '?action=managegames;sa=files',
		'is_selected' => in_array($_REQUEST['sa'], array('files', 'install', 'install2')),
		'is_last' => true,
	);

	$context['template_layers'][] = 'games';

	// Call action
	$subActions[$_REQUEST['sa']][0]();
}

function GamesDelete()
{
	global $scripturl, $txt, $db_prefix, $context, $sourcedir;

	checkSession('get');

	$game = ArcadeGameInfo((int) $_REQUEST['game'], null, true);

	if ($game === false)
		redirectexit('action=managegames');

	db_query("
		DELETE FROM {$db_prefix}arcade_games
		WHERE ID_GAME = $game[id]", __FILE__, __LINE__);

	db_query("
		DELETE FROM {$db_prefix}arcade_scores
		WHERE ID_GAME = $game[id]", __FILE__, __LINE__);

	redirectexit('action=managegames');
}

function GamesQuickEdit()
{
	global $scripturl, $txt, $db_prefix, $context;

	checkSession('post');

	if (!isset($_REQUEST['qaction']))
		redirectexit('action=managegames');

	elseif ($_REQUEST['qaction'] == 'fix_scores')
	{
		$res = db_query("
			SELECT ID_GAME
			FROM {$db_prefix}arcade_games", __FILE__, __LINE__);

		while ($game = mysql_fetch_assoc($res))
			ArcadeFixPositions($game['ID_GAME']);

		mysql_free_result($res);
	}
	elseif ($_REQUEST['qaction'] == 'change')
	{
		$category = (int) $_POST['qcategory'];

		if ($_REQUEST['qset'] == 0)
		{
			$games = implode(',', $_POST['games']);
			db_query("
				UPDATE {$db_prefix}arcade_games
				SET ID_CAT = $category
				WHERE ID_GAME IN($games)", __FILE__, __LINE__);
		}
		else
			db_query("
				UPDATE {$db_prefix}arcade_games
				SET ID_CAT = $category", __FILE__, __LINE__);
	}
	elseif ($_REQUEST['qaction'] == 'clear_scores')
	{
		if ($_REQUEST['qset'] == 0)
		{
			$games = implode(',', $_POST['games']);
			$category = (int) $_POST['qcategory'];

			db_query("
				DELETE FROM {$db_prefix}arcade_scores
				WHERE ID_GAME IN($games)", __FILE__, __LINE__);

			foreach ($games as $game)
				ArcadeFixPositions($game);

		}
		else
		{
			db_query("
				DELETE FROM {$db_prefix}arcade_scores", __FILE__, __LINE__);

			$res = db_query("
				SELECT ID_GAME
				FROM {$db_prefix}arcade_games", __FILE__, __LINE__);

			while ($game = mysql_fetch_assoc($res))
				ArcadeFixPositions($game['ID_GAME']);

			mysql_free_result($res);
		}

	}

	redirectexit('action=managegames');

}

function prepareEditor($game)
{
	global $scripturl, $txt, $db_prefix, $context;

	$context['arcade']['category'] = prepareCategories();
	$category = array();
	foreach ($context['arcade']['category'] as $cat)
		$category[] = array(
			'value' => $cat['id'],
			'name' => $cat['name'],
		);

	prepareMemberGroups(isset($_POST['data']['memberGroups']) ? $_POST['data']['memberGroups'] : explode(',', $game['memberGroups']));

	$_POST['data']['enabled'] = isset($_POST['data']['enabled']) ? true : isset($_POST['data']['internalName']) ? false : $game['enabled'];

	$context['arcade']['config_array'] = array(
		$txt['arcade_basic_settings'],
			array(
				'name' => 'internalName',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_internal_name'],
				'value' => isset($_POST['data']['internalName']) ? $_POST['data']['internalName'] : $game['internalName'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'gameName',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_game_name'],
				'value' => isset($_POST['data']['gameName']) ? $_POST['data']['gameName'] : $game['name'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'gameFile',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_file_name'],
				'value' => isset($_POST['data']['gameFile']) ? $_POST['data']['gameFile'] : $game['file'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'gameDirectory',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_directory'],
				'value' => isset($_POST['data']['gameDirectory']) ? $_POST['data']['gameDirectory'] : $game['directory'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'gameType',
				'type' => 'select',
				'help' => '',
				'label' => $txt['arcade_game_type'],
				'value' => isset($_POST['data']['gameType']) ? $_POST['data']['gameType'] : $game['gameType'],
				'data' => array(
					array('value' => 0, 'name' => $txt['arcade_game_type_flash'])
				),
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'scoreType',
				'type' => 'select',
				'help' => '',
				'label' => $txt['arcade_score_type'],
				'value' => isset($_POST['data']['scoreType']) ? $_POST['data']['scoreType'] : $game['scoreType'],
				'data' => array(
					array('value' => 0, 'name' => $txt['arcade_score_normal']),
					array('value' => 1, 'name' => $txt['arcade_score_reverse']),
					array('value' => 2, 'name' => $txt['arcade_score_none']),
				),
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'ID_CAT',
				'type' => 'select',
				'help' => '',
				'label' => $txt['arcade_category'],
				'value' => isset($_POST['data']['ID_CAT']) ? $_POST['data']['ID_CAT'] : $game['category']['id'],
				'data' => &$category,
				'disabled' => false,
			),
			array(
				'name' => 'enabled',
				'type' => 'checkbox',
				'help' => '',
				'label' => $txt['arcade_enabled'],
				'checked' => isset($_POST['data']['enabled']) ? $_POST['data']['enabled'] : $game['enabled'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'maxScores',
				'type' => 'text',
				'help' => 'arcade_max_scores_help',
				'label' => $txt['arcade_max_scores'],
				'value' => isset($_POST['data']['maxScores']) ? $_POST['data']['maxScores'] : $game['maxScores'],
				'disabled' => false,
				'size' => 30,
			),
			// Permission (this is special one)
			array(
				'name' => 'memberGroups',
				'label' => $txt['arcade_membergroups'],
				'type' => 'permission',
				'help' => 'arcade_membergroups_help',
				'disabled' => false,

			),
		$txt['arcade_thumbnails'],
			array(
				'name' => 'thumbnail',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_thumbnail'],
				'value' => isset($_POST['data']['thumbnail']) ? $_POST['data']['thumbnail'] : $game['thumbnail'],
				'disabled' => false,
				'size' => 30,
			),
			array(
				'name' => 'thumbnailSmall',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_thumbnail_small'],
				'value' => isset($_POST['data']['thumbnailSmall']) ? $_POST['data']['thumbnailSmall'] : $game['thumbnailSmall'],
				'disabled' => false,
				'size' => 30,
			),
		$txt['arcade_description_help'],
			array(
				'name' => 'description',
				'type' => 'large_text',
				'help' => '',
				'label' => $txt['arcade_description'],
				'value' => isset($_POST['data']['description']) ? stripcslashes($_POST['data']['description']) : $game['description'],
				'disabled' => false,
				'rows' => 3,
				'cols' => 30,
			),
			array(
				'name' => 'help',
				'type' => 'large_text',
				'help' => '',
				'label' => $txt['arcade_help'],
				'value' =>  isset($_POST['data']['help']) ? $_POST['data']['help'] : $game['help'],
				'disabled' => false,
				'rows' => 3,
				'cols' => 30,
			),
		$txt['arcade_flash_only'],
			array(
				'name' => 'gameWidth',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_width'],
				'value' => isset($_POST['data']['gameWidth']) ? $_POST['data']['gameWidth'] : $game['flash']['width'],
				'disabled' => $game['gameType'] != 0,
				'size' => 30,
			),
			array(
				'name' => 'gameHeight',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_height'],
				'value' => isset($_POST['data']['gameHeight']) ? $_POST['data']['gameHeight'] : $game['flash']['height'],
				'disabled' => $game['gameType'] != 0,
				'size' => 30,
			),
			array(
				'name' => 'gameBackgroundColor',
				'type' => 'text',
				'help' => '',
				'label' => $txt['arcade_bgcolor'],
				'value' => isset($_POST['data']['gameBackgroundColor']) ? $_POST['data']['gameBackgroundColor'] : $game['flash']['backgroundColor'],
				'disabled' => $game['gameType'] != 0,
				'size' => 30,
			),
	);
}

function GamesAdminEditor()
{
	global $scripturl, $txt, $db_prefix, $context;

	if (!isset($_REQUEST['game']))
		fatal_error('arcade_no_game');

	$game = ArcadeGameInfo((int) $_REQUEST['game'], null, true);
	if ($game === false)
		fatal_error('arcade_no_game');

	$context['arcade']['config_errors'] = array();
	prepareEditor($game);

	// Title for page
	$context['page_title'] = $txt['arcade_title_manage_games'] . ' - ' . $game['name'];

	// Template layers for editor
	$context['template_layers'][] = 'editor';
	$context['sub_template'] = 'arcadeadmin_editor';

	// Game data
	$context['arcade']['game'] = &$game;
}

function GamesAdminEditor2()
{
	global $scripturl, $txt, $db_prefix, $context;

	if (!isset($_POST['data']['enabled']))
		$_POST['data']['enabled'] = false;

	if (!isset($_REQUEST['game']))
		fatal_error('arcade_no_game');

	$game = ArcadeGameInfo((int) $_REQUEST['game'], null, true);
	if ($game === false)
		fatal_error('arcade_no_game');

	$errors = UpdateGame((int) $_REQUEST['game'], $_POST['data']);

	// There were no errors no need to display this again
	if (count($errors) === 0)
	{
		if (!isset($_SESSION['arcade_page']))
			redirectexit('action=managegames');
		else
			redirectexit('action=managegames;start=' . $_SESSION['arcade_page']);
	}

	$context['arcade']['config_errors'] = &$errors;
	prepareEditor($game);

	// Title for page
	$context['page_title'] = $txt['arcade_title_manage_games'] . ' - ' . $game['name'];
	// Template layers for editor
	$context['template_layers'][] = 'editor';
	$context['sub_template'] = 'arcadeadmin_editor';
	// Game data
	$context['arcade']['game'] = &$game;
}

function GamesAdminList()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $sourcedir;

	$where = '1';
	$search = false;

	if (isset($_REQUEST['category']))
	{
		$search = true;
		$category = (int) $_REQUEST['category'];

		if (empty($where))
			$where = "game.ID_CAT = $category";
		else
			$where = " AND game.ID_CAT = $category";
	}

	$result_count = db_query("
		SELECT count(*) as gc
		FROM {$db_prefix}arcade_games AS game
		LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
		WHERE $where", __FILE__, __LINE__);

	$gameCount = mysql_fetch_assoc($result_count);
	mysql_free_result($result_count);

	$gamesPerPage = !empty($modSettings['gamesPerPage']) ? $modSettings['gamesPerPage'] : 25;

	$result_games = db_query("
		SELECT
			game.ID_GAME, game.gameName, game.description, game.gameRating, game.numPlays, game.gameFile,
			game.gameDirectory, game.gameType, game.internalName, game.gameWidth, game.gameHeight,
			game.gameBackgroundColor AS bgcolor, game.scoreType, game.maxScores, game.thumbnail,
			game.thumbnailSmall, game.help, game.enabled, IFNULL(category.ID_CAT, 0) AS ID_CAT, IFNULL(category.catName, '') As catName
		FROM {$db_prefix}arcade_games AS game
			LEFT JOIN {$db_prefix}arcade_categories AS category ON (category.ID_CAT = game.ID_CAT)
		WHERE $where
		ORDER BY gameName
		LIMIT $_REQUEST[start], $gamesPerPage", __FILE__, __LINE__);

	$context['arcade']['games'] = array();
	$context['arcade']['search'] = $search;

	$parts = array(
		$scripturl . '?action=managegames'
	);

	if ($search)
	{
		if (isset($category))
			$parts[] = 'category=' . $category;

	}

	$context['arcade']['pageIndex'] = constructPageIndex(implode(';', $parts) , $_REQUEST['start'], $gameCount['gc'] , $gamesPerPage, false );

	$_SESSION['arcade_page'] = $_REQUEST['start'];

	while ($game = mysql_fetch_assoc($result_games))
		$context['arcade']['games'][] = BuildGameArrayAdmin($game);

	mysql_free_result($result_games);

	// Title for page
	$context['page_title'] = $txt['arcade_title_manage_games'];
	// Subtemplate
	$context['sub_template'] = 'games_list';
}

function GamesAdminFiles()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $sourcedir, $func;

	if (!isset($_REQUEST['directory'])) // In main directory
	{
		$directory = $modSettings['gamesDirectory'] . '/';
		$base_url = $scripturl . '?action=managegames;sa=files';
		$base_dir = '';
	}
	else
	{
		$directory = $modSettings['gamesDirectory'] . '/' . $_REQUEST['directory'] . '/';
		$base_url = $scripturl . '?action=managegames;sa=files;directory=' . $_REQUEST['directory'];
		$base_dir = $_REQUEST['directory'] . '/';
	}

	$context['arcade']['files'] = array();
	$context['arcade']['directories'] = array();

	$result = db_query("
		SELECT gameFile
		FROM {$db_prefix}arcade_games", __FILE__, __LINE__);

	$installed = array();
	while ($file = mysql_fetch_assoc($result))
		$installed[$file['gameFile']] = true;

	if ($handle = opendir($directory))
	{
		while (($file = readdir($handle)) !== false)
		{
			if ($file == '.' || $file == '..' || isset($installed[$file]))
				continue;

			if (is_dir($directory . $file))
			{
				$context['arcade']['directories'][] = array(
					'name' => $file,
					'writeable' => is_writable($directory . $file),
					'path' => $directory . $file,
					'url' => array(
						'view' => $scripturl . '?action=managegames;sa=files;directory=' . $base_dir . $file
					)
				);
			}
			else
			{
				$dot = strrpos($file, '.');

				if ($dot !== false)
					$internal_name = $func['substr']($file, 0, $dot);
				else
					continue;

				if ($func['substr']($file, -3) == 'swf')
					$type = 'flash';

				elseif ($func['substr']($file, -3) == 'tar' || $func['substr']($file, -6) == 'tar.gz' || $func['substr']($file, -3) == 'zip')
					$type = 'compress';

				else
					continue;

				$file_url = !empty($base_dir) ? $base_dir . $file : $file;
				$context['arcade']['files'][] = array(
					'name' => $func['ucwords'](strtr($internal_name, array('_' => ' '))),
					'file' => $file,
					'writeable' => is_writable($directory . $file),
					'path' => $base_dir . $file,
					'type' => $type,
					'url' => array(
						'install' => $scripturl . '?action=managegames;sa=install;file=' . $file_url,
					),
				);
			}
		}
	}

	// Title for page
	$context['page_title'] = $txt['arcade_title_install_games'];
	// Subtemplate
	$context['sub_template'] = 'files_list';

}

function GamesAdminInstall()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $sourcedir, $boarddir, $func;

	// Make list of files to be installed
	if (isset($_REQUEST['file']) || isset($_REQUEST['directory']))
	{
		// We don't want to install games more than once
		$result = db_query("
			SELECT gameFile FROM {$db_prefix}arcade_games", __FILE__, __LINE__);

		$installed = array();
		while ($file = mysql_fetch_assoc($result))
			$installed[$file['gameFile']] = true;

		// We need write permission to games directory
		if (!is_writable($modSettings['gamesDirectory']))
			fatal_lang_error('arcade_not_writeable', false, array($modSettings['gamesDirectory']));

		// We will need this to extract files
		require_once($sourcedir . '/Subs-Package.php');

		// One file
		if (isset($_REQUEST['file']) && !is_array($_REQUEST['file']))
			$files = array($_REQUEST['file']);
		// Many files
		elseif (isset($_REQUEST['file']) && is_array($_REQUEST['file']))
			$files = &$_REQUEST['file'];
		// No files at all
		else
			$files = array();

		// Remove invalid games
		foreach ($files as $key => $value)
			if (!file_exists($modSettings['gamesDirectory'] . '/' . $value))
				unset($files[$key]);

		// Files from directories
		if (isset($_REQUEST['directory']) && is_array($_REQUEST['directory']))
		{
			chdir($modSettings['gamesDirectory']);

			foreach ($_REQUEST['directory'] as $directory)
				$files = array_merge($files, glob($directory . '/*.swf'));

		}

		if (count($files) == 0)
			fatal_lang_error('arcade_no_files_selected');

		$games = array();

		// Let's make array with basic settings
		foreach ($files as $file)
		{
			$path = $file;
			$file = basename($file);
			$dot = strrpos($file, '.');

			if ($dot !== false)
				$internal_name = $func['substr']($file, 0, $dot);
			else
				fatal_lang_error('arcade_invalid_file', false, array($path));

			if ($func['substr']($file, -3) == 'swf')
			{

				// Is it already installed?
				if (isset($installed[$file]))
					continue;

				$name = str_replace('_', ' ', $internal_name);
				$games[$internal_name] = array(
					'internalName' => $internal_name,
					'name' => $func['ucwords']($name),
					'path' => $path,
					'file' => $file,
					'type' => $func['substr']($file, -3),
				);

			}
			elseif ($func['substr']($file, -3) == 'zip')
			{

				$data = file_get_contents($modSettings['gamesDirectory'] . '/' . $path);

				if ($data === false)
					continue; // Unable to read file :(

				$destination = $modSettings['gamesDirectory'] . '/' . $internal_name . '/';
				$ret = read_zip_data($data, $destination);
				unset($data);

				$folder = $internal_name;

				if ($ret == false)
					continue;

				// Files that were extracted
				foreach ($ret as $file_pack)
				{
					$basename = basename($file_pack['filename']);

					// Is it already installed?
					if (isset($installed[ $basename ]))
						continue;

					$path = $folder . '/' . $basename;
					$dot = strpos($file_pack['filename'], '.');

					if ($dot !== false)
						$internal_name = $func['substr']($basename, 0, $dot);
					else
						fatal_lang_error('arcade_invalid_file', false, array($path));

					if ($func['substr']($basename, -3) == 'swf')
					{
						$name = str_replace('_', ' ', $internal_name);
						$games[$internal_name] = array(
							'internalName' => $internal_name,
							'name' => $func['ucwords']($name),
							'path' => $path,
							'file' => $basename,
							'type' => $func['substr']($file_pack['filename'], -3),
						);
					}

				}
			}
		}

		// There were packages with errors or no games...
		if (count($games) == 0)
			fatal_lang_error('arcade_no_files_selected');

		// Session will store data
		$_SESSION['install'] = array(
			'to_check' => $games,
			'games' => array(),
			'done' => 0,
			'total' => count($files),
			'begin' => time(),
			'end' => 0,
		);

		redirectexit('action=managegames;sa=install');

	}
	// Do we install in progress?
	elseif (isset($_SESSION['install']))
	{
		// Do we use GetID3?
		if (!empty($modSettings['useGetID3']))
		{
			require_once($boarddir . '/getid3/getid3.php');
			$method = 'getid3';
		}
		else
			$method = 'php';

		$install = &$_SESSION['install'];
		$context['arcade']['install'] = array();

		// Games that needs to be checked
		foreach ($install['to_check'] as $key => $file)
		{
			// If we have flash, we need meta-data such as width and height
			if ($file['type'] == 'swf')
			{
				// Try to load information from cache if it exists
				if (file_exists($modSettings['gamesDirectory'] . '/' . $file['path'] . '.cache') && filemtime($modSettings['gamesDirectory'] . '/' . $file['path'] . '.cache') > $modSettings['gamesDirectory'] . '/' . $file['path'])
				{
					$temp = file($modSettings['gamesDirectory'] . '/' . $file['path'] . '.cache');
					$cache = unserialize($temp[0]);
					unset($temp);

					$file['width'] = $cache['width'];
					$file['height'] = $cache['height'];
					$file['bgcolor'] = isset($cache['bgcolor']) ? $cache['bgcolor'] : '';

				}
				// Do we use GetID3 to get meta-data?
				elseif ($method == 'getid3')
				{
					$swf = new getID3;
					$swf->analyze($modSettings['gamesDirectory'] . '/' . $file['path']);

					$file['width'] = $swf->info['video']['resolution_x'];
					$file['height'] = $swf->info['video']['resolution_y'];
					$file['bgcolor'] = $swf->info['swf']['bgcolor'];

				}
				// What about GetImageSize
				elseif ($method == 'php')
				{
					$meta = getimagesize($modSettings['gamesDirectory'] . '/' . $file['path']);

					$file['width'] = $meta[0];
					$file['height'] = $meta[1];
					$file['bgcolor'] = '';
				}
			}

			// Change working directory and try to find thumbails
			$directory = substr($file['path'], 0, strrpos($file['path'], '/'));
			chdir($modSettings['gamesDirectory'] . '/' . $directory);
			$thumbnail = glob($file['internalName'] . '{1.png,1.gif,1.jpg,.png,.gif,.jpg}', GLOB_BRACE);
			$thumbnailSmall = glob($file['internalName'] . '2.{png,gif,jpg}', GLOB_BRACE);

			// Build array
			$context['arcade']['install'][] = array(
				'gameName' => $file['name'],
				'internalName' => $file['internalName'],
				'directory' => $directory,
				'file' => $file['file'],
				'thumbnail' => isset($thumbnail[0]) ? $thumbnail[0] : '',
				'thumbnailSmall' => isset($thumbnailSmall[0]) ? $thumbnailSmall[0] : '',
				'gameType' => $file['type'] == 'swf' ? 0 : 1,
				'scoreType' => 0,
				'width' => $file['width'],
				'height' => $file['height'],
				'bgcolor' => $file['bgcolor'],
			);
		}

		$_SESSION['install2'] = $context['arcade']['install'];
		$context['arcade']['categories'] = prepareCategories();

		// Template
		$context['page_title'] = $txt['arcade_title_install_games'];
		$context['sub_template'] = 'games_install';
	}
	else
		fatal_lang_error('arcade_no_files_selected');

}

function GamesAdminInstall2()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context;

	checkSession('post');

	if (!isset($_SESSION['install2']) || !isset($_POST['defaults']) || !isset($_POST['game']) || !is_array($_POST['defaults']) || !is_array($_POST['game']))
		fatal_lang_error('arcade_no_files_selected');


	$messages = array();
	foreach ($_SESSION['install2'] as $game2)
		$messages = array_merge($messages, createGame(array_merge($_POST['defaults'], array_merge($game2, $_POST['game'][$game2['internalName']]))));

	$context['arcade']['messages'] = &$messages;
	unset($_SESSION['install']);

	// Template
	$context['page_title'] = $txt['arcade_title_install_games'];
	$context['sub_template'] = 'games_install_complete';
}

function GamesUpload()
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context;

	// We need this
	loadLanguage('Packages');

	// Was upload successful?
	if (!isset($_FILES['package']['name']) || $_FILES['package']['name'] == '' || !is_uploaded_file($_FILES['package']['tmp_name']) || (@ini_get('open_basedir') == '' && !file_exists($_FILES['package']['tmp_name'])))
		fatal_lang_error('package_upload_error');

	// Remove dangerous / non websafe characters
	$_FILES['package']['name'] = preg_replace(array('/\s/', '/\.[\.]+/', '/[^\w_\.\-]/'), array('_', '.', ''), $_FILES['package']['name']);

	if (strtolower(substr($_FILES['package']['name'], -4)) != '.zip')
		fatal_error($txt['package_upload_error_supports'] . 'zip', false);

	// Get filename
	$filename = basename($_FILES['package']['name']);

	// Where it will be saved?
	$destination = $modSettings['gamesDirectory'] . '/' . $filename;

	// It is already here
	if (file_exists($destination))
		fatal_lang_error('package_upload_error_exists');

	// Move and make writeable
	move_uploaded_file($_FILES['package']['tmp_name'], $destination);
	@chmod($destination, 0777);

	redirectexit('action=managegames;sa=install;file='. $filename);
}

function createGame($game)
{
	global $scripturl, $txt, $db_prefix, $modSettings, $context, $sourcedir, $boarddir, $func;

	$errors = array();

	// Membergroups
	if (isset($game['memberGroups']) && is_array($game['memberGroups']))
		$game['memberGroups'] =	implode(',', $game['memberGroups']);

	// Defaults
	$default = array(
		'ID_CAT' => $modSettings['arcadeDefaultCategory'],
		'width' => 0,
		'height' => 0,
		'description' => '',
		'help' => '',
		'directory' => '',
		'scoreType' => 0,
		'gameType' => 0,
		'bgcolor' => '',
		'gameExtraData' => '',
		'thumbnail' => '',
		'thumbnailSmall' => '',
		'memberGroups' => '-1,0,2',
		'maxScores' => -1,
		'enabled' => 1,
	);

	// We convert these to MySQL field names
	$convert = array(
		'width' => 'gameWidth',
		'height' => 'gameHeight',
		'file' => 'gameFile',
		'directory' => 'gameDirectory',
		'bgcolor' => 'gameBackgroundColor',
	);

	// Add missing values which have default values
	foreach ($default as $key => $value)
		if (!isset($game[$key]))
			$game[$key] = $value;

	// Convert
	foreach ($convert as $from => $to)
		if (isset($game[$from]))
		{
			$game[$to] = $game[$from];
			unset($game[$from]);
		}

	// Types
	$numeric = array('gameWidth', 'gameHeight', 'scoreType', 'gameType', 'maxScores', 'ID_CAT');

	// What is required always and may not be empty
	$required = array('internalName', 'gameName', 'gameFile');

	// Check regured values
	foreach ($required as $key)
		if (!isset($game[$key]))
			$errors[] = sprintf($txt['arcade_field_error'], $game['file'], $key, $txt['arcade_filed_numeric']);

	// Check numeric values
	foreach ($numeric as $key)
		if (!is_numeric($game[$key]))
			$errors[] = sprintf($txt['arcade_field_error'], $game['gameName'], $key, $txt['arcade_filed_numeric']);

	// We have error :(
	if (count($errors) > 0)
		return $errors;

	// Build Query
	$values = array();

	foreach ($game as $key => $value)
		if (in_array($key, $numeric))
			$values[] = $key . ' = ' . $value;
		else
			$values[] = $key . ' = "' . mysql_real_escape_string($value) . '"';

	//die(print_r($values));
	db_query("
		INSERT INTO {$db_prefix}arcade_games
		SET " . implode(', ', $values), __FILE__, __LINE__);

	// Success
	$gameid = db_insert_id();

	return array(sprintf($txt['arcade_game_installed'], '<a href="' . $scripturl . '?game=' . $gameid . '">' . $game['gameName'] . '</a>'));;
}

?>