<?php
// Version: 2.0.8; Arcade

function template_arcade_above()
{
	global $scripturl, $txt, $context;

	echo '
	<div style="padding: 3px;">', theme_linktree(), '</div>';

	if (!empty($context['arcade_tabs']))
	{
		echo '
	<div class="tborder">
		<table class="bordercolor" border="0" cellpadding="4" cellspacing="1" width="100%">
			<tr class="titlebg">
				<td colspan="2">
					', $context['arcade_tabs']['title'], '
				</td>
			</tr>
			', isset($context['arcade']['notice']) ? '
			<tr class="windowbg2">
				<td colspan="2">' . $context['arcade']['notice'] . '</td>
			</tr>' : '', '
			<tr class="catbg">
				<td align="center">', $txt['arcade_game_highlights'], '</td>
				<td align="center">', $txt['arcade_latest_scores'], '</td>
			</tr>
			<tr class="windowbg">
				<td class="smalltext" style="padding: 2ex; text-align: center;">';

		if ($context['arcade']['longest_champion'] !== false)
			echo sprintf($txt['arcade_game_with_longest_champion'], $context['arcade']['longest_champion']['member_link'], $context['arcade']['longest_champion']['game_link']), '<br />';

		if ($context['arcade']['most_played'] !== false)
			echo sprintf($txt['arcade_game_most_played'], $context['arcade']['most_played']['link']), '<br />';

		if ($context['arcade']['best_player'] !== false)
			echo sprintf($txt['arcade_game_best_player'], $context['arcade']['best_player']['link']), '<br />';

		if ($context['arcade']['stats']['games'] != 0)
			echo sprintf($txt['arcade_game_we_have_games'], $context['arcade']['stats']['games']), '<br />';

		echo '
				</td>
				<td class="smalltext" style="padding: 2ex; text-align: center;">';

		if (count($context['arcade']['latest_scores']) > 0)
			foreach ($context['arcade']['latest_scores'] as $score) // Print out latest scores
				printf($txt['arcade_latest_score'], $scripturl . '?action=arcade;sa=play;game=' . $score['game_id'], $score['name'], $score['score'], $score['memberLink'], strip_tags($score['time']));
		else
			echo $txt['arcade_no_scores'];

		echo '
				</td>
			</tr>
		</table>
	</div>

	<table cellpadding="0" cellspacing="0" border="0" style="margin-left: 10px;">
		<tr>
			<td class="maintab_first">&nbsp;</td>';

			// Print out all the items in this tab.
			foreach ($context['arcade_tabs']['tabs'] as $tab)
			{
				if (!empty($tab['is_selected']))
				{
					echo '
			<td class="maintab_active_first">&nbsp;</td>
			<td valign="top" class="maintab_active_back">
				<a href="', $tab['href'], '">', $tab['title'], '</a>
			</td>
			<td class="maintab_active_last">&nbsp;</td>';

					$selected_tab = $tab;
				}
				else
					echo '
			<td valign="top" class="maintab_back">
				<a href="', $tab['href'], '">', $tab['title'], '</a>
			</td>';
			}

			// the end of tabs
			echo '
			<td class="maintab_last">&nbsp;</td>
		</tr>
	</table><br />';

	}

	echo '
	<div style="padding-top: 5px;">
		<a name="top"></a>';

}

// Game list
function template_arcade_list()
{
	global $scripturl, $txt, $context, $settings;

	$arcade = array(
		'random' => array(
			'text' => 'arcade_random_game',
			'image' => 'arcade_random.gif', // Theres no image for this included (yet)
			'url' => $scripturl . '?action=arcade;sa=play;random',
			'lang' => true
		),
		'favorites' => array(
			'text' => 'arcade_favorites_only',
			'image' => 'arcade_favorites.gif',
			'url' => $scripturl . '?action=arcade;favorites',
			'lang' => true
		),
	);

	if (isset($context['arcade']['search']) && $context['arcade']['search'])
		$arcade['search'] = array(
			'text' => 'arcade_show_all',
			'image' => 'arcade_search.gif',
			'url' => $scripturl . '?action=arcade',
			'lang' => true
		);


	// Header for Game listing
	echo '
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td class="middletext" style="padding-bottom: 4px;" valign="bottom">', $txt[139], ': ', $context['arcade']['pageIndex'], '   &nbsp;&nbsp;<a href="#bot"><b>', $txt['topbottom5'], '</b></a></td>
				<td style="padding-right: 1ex;" align="right">
					<table cellpadding="0" cellspacing="0">
						<tr>', template_button_strip($arcade, 'bottom'), '</tr>
					</table>
				</td>
			</tr>
		</table>

		<div class="tborder">
			<table class="bordercolor" border="0" cellpadding="4" cellspacing="1" width="100%">';

	// Is there games?
	if (count($context['arcade']['games']) > 0)
	{

		// Header
		echo '
				<tr>
					<td class="catbg3"></td>
					<td class="catbg3"><a href="', $scripturl, '?action=arcade;sort=name', $context['sort_by'] == 'name' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['arcade_game_name'], $context['sort_by'] == 'name' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
					<td class="catbg3"><a href="', $scripturl, '?action=arcade;sort=myscore', $context['sort_by'] == 'myscore' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['arcade_personal_best'], $context['sort_by'] == 'myscore' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
					<td class="catbg3"><a href="', $scripturl, '?action=arcade;sort=champion', $context['sort_by'] == 'champion' && $context['sort_direction'] == 'up' ? ';desc' : '', '">', $txt['arcade_champion'], $context['sort_by'] == 'champion' ? ' <img src="' . $settings['images_url'] . '/sort_' . $context['sort_direction'] . '.gif" alt="" />' : '', '</a></td>
				</tr>';

		// Loop thought all games in page
		foreach ($context['arcade']['games'] as $game)
		{
			// Print out game information
			echo '
				<tr>
					<td class="windowbg2" style="width: 60px;" align="center">', $game['thumbnail'] != '' ? '
						<a href="' . $game['url']['play'] . '"><img width="60" src="' . $game['thumbnail'] . '" alt="" /></a>' : '', '
					</td>
					<td class="windowbg">
						<div style="float: left">
							<div><a href="', $game['url']['play'], '">', $game['name'], '</a></div>';
			// Is there description?

			if (!empty($game['description']))
				echo '
							<div class="smalltext">', $game['description'], '</div>';

			if ($game['highscoreSupport']) // Does this game support highscores?
				echo '
							<div class="smalltext"><a href="' . $game['url']['highscore'] . '">' . $txt['arcade_viewscore'] . '</a></div>
							', $game['maxScores'] > 0 ? '<div class="smalltext">' . sprintf($txt['arcade_you_may_have_only'], $game['maxScores']) . '</div>' : '', '
							</div>';

			echo '
						</div>
						<div style="float: right; text-align: right;" class="smalltext">';
			// Rating

			if ($game['rating2'] > 0)
				echo '
						<div>',
							str_repeat('<img src="' . $settings['images_url'] . '/star.gif" alt="*" />' , $game['rating2']),
							str_repeat('<img src="' . $settings['images_url'] . '/star2.gif" alt="" />' , 5 - $game['rating2']), '</div>';

			// Category

			if ($game['category']['name'] != '')
				echo '
								<a href="', $game['category']['link'], '">', $game['category']['name'], '</a><br />';

			// Favorite link (if can favorite)
			if ($context['arcade']['can_favorite'])
				echo '
							<a href="', $game['url']['favorite'], '" onclick="arcade_favorite(', $game['id'] , '); return false;">
								', !$game['isFavorite'] ?
								'<img id="favgame' . $game['id'] . '" src="' . $settings['images_url'] . '/favorite.gif" alt="' . $txt['arcade_add_favorites'] . '" />' :
								'<img id="favgame' . $game['id'] . '" src="' . $settings['images_url'] . '/favorite2.gif" alt="' . $txt['arcade_remove_favorite'] .'" />', '</a>';

			echo '
						</div>
					</td>';

			// Show personal best and champion only if game doest support highscores
			if ($game['highscoreSupport'] && $game['isChampion'])
				echo '
					<td class="windowbg2" style="width: 15%; text-align: center;">
						', $game['isPersonalBest'] ? $game['personalBest'] :  $txt['arcade_no_scores'], '
					</td>

					<td class="windowbg2" style="width: 15%; text-align: center;">
						', $game['champion']['memberLink'], '<br />', $game['champion']['score'], '
					</td>';

			elseif (!$game['highscoreSupport'])
				echo '
					<td class="windowbg2" colspan="2" style="text-align: center; width: 30%;">', $txt['arcade_no_highscore'], '</td>';
			else
				echo '
					<td class="windowbg2" colspan="2" style="text-align: center; width: 30%;">', $txt['arcade_no_scores'], '</td>';


			echo '
				</tr>';
		}

		/*
		// Footer for game listing
		echo '
				<tr class="catbg">
					<td></td>
					<td>', $txt['arcade_game_name'], '</td>
					<td>', $txt['arcade_personal_best'], '</td>
					<td>', $txt['arcade_champion'], '</td>
				</tr>';*/

	}
	else
	{
		// There is no games installed / found.
		echo '
				<tr>
					<td class="catbg3"><b>', $txt['arcade_no_games'], '</b></td>
				</tr>';
	}

	echo '
			</table>
		</div>

		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td class="middletext">', $txt[139], ': ', $context['arcade']['pageIndex'], '   &nbsp;&nbsp;<a href="#top"><b>', $txt['topbottom4'], '</b></a></td>
				<td style="padding-right: 1ex;" align="right">
					<table cellpadding="0" cellspacing="0">
						<tr>', template_button_strip($arcade, 'top'), '</tr>
					</table>
				</td>
			</tr>
		</table>';
}

function template_ArcadeGame_above()
{
	global $scripturl, $txt, $context, $settings;

	// Play link
	$context['arcade']['buttons']['play'] =  array(
		'text' => 'arcade_play',
		'image' => 'arcade_play.gif', // Theres no image for this included (yet)
		'url' => $context['arcade']['play'] ? $scripturl . '?action=arcade;sa=play;game=' . $context['arcade']['game']['id'] . '" onclick="arcadeRestart(); return false;' : $scripturl . '?action=arcade;sa=play;game=' . $context['arcade']['game']['id'],
		'lang' => true
	);

	// Highscores link if it is supported
	if ($context['arcade']['game']['highscoreSupport'])
		$context['arcade']['buttons']['score'] =  array(
			'text' => 'arcade_viewscore',
			'image' => 'arcade_viewscore.gif', // Theres no image for this included (yet)
			'url' => $scripturl . '?action=arcade;sa=highscore;game=' . $context['arcade']['game']['id'],
			'lang' => true
		);

	// Random game
	$context['arcade']['buttons']['random'] =  array(
		'text' => 'arcade_random_game',
		'image' => 'arcade_random.gif', // Theres no image for this included (yet)
		'url' => $scripturl . '?action=arcade;sa=play;random',
		'lang' => true
	);

	echo '
					<table border="0" cellpadding="0" cellspacing="0" width="100%">
						<tr>
							<td class="middletext">
								', isset($context['arcade']['pageIndex']) ? $txt[139] . ': ' . $context['arcade']['pageIndex'] : '' ,'
							</td>
							<td style="padding-right: 1ex;" align="right">
								<table cellpadding="0" cellspacing="0">
									<tr>
										', template_button_strip($context['arcade']['buttons'], 'bottom'), '
									</tr>
								</table>
							</td>
						</tr>
					</table>';
}

// Play screen
function template_arcade_game_play()
{
	global $scripturl, $txt, $context, $settings;

	echo '
					<div class="tborder">
						<table class="bordercolor" border="0" cellpadding="4" cellspacing="1" width="100%">
							<tr class="catbg">
								<td>', $context['arcade']['game']['name'], '</td>
							</tr>
							<tr class="windowbg">
								<td>
									<div style="text-align: center;">
										', $context['arcade']['game']['html'], '
										', !$context['arcade']['can_submit'] ? '<br /><b>' . $txt['arcade_cannot_save'] . '</b>' : '', '
									</div>
								</td>
							</tr>
						</table>
					</div>';

}

// Highscore
function template_arcade_game_highscore()
{
	global $scripturl, $txt, $context, $settings;

	$game = &$context['arcade']['game'];

	echo '
					<div class="tborder">
						<table class="bordercolor" border="0" cellpadding="4" cellspacing="1" width="100%">';

	if (isset($context['arcade']['new_score'])) // Was score submitted
	{
		$score = &$context['arcade']['new_score'];

		echo '
							<tr class="titlebg">
								<td colspan="5">', $txt['arcade_submit_score'], '</td>
							</tr>
							<tr class="windowbg">
								<td colspan="5" style="text-align: center;">';

		if (!$score['saved'])
			// No permission to save
			echo '
			<div>', $txt[$score['error']], '<br />
			<strong>', $txt['arcade_score'], ':</strong> ', $score['score'], '</div>';

		else
		{
			echo '
			<div>', $txt['arcade_score_saved'], '</div>
			<div><strong>', $txt['arcade_score'], ':</strong> ', $score['score'], '</div>';

			if ($score['is_new_champion'])
				echo '
				<div>', $txt['arcade_you_are_now_champion'], '</div>';

			elseif ($score['is_personal_best'])
				echo '
				<div>', $txt['arcade_this_is_your_best'], '</div>';

			if ($score['can_comment'])
				echo '
				<div id="edit', $score['id'], '">
					<form action="', $scripturl, '?action=arcade;sa=comment;game=', $game['id'], ';score=',  $score['id'], '" onsubmit="arcadeCommentEdit(', $score['id'], ', ', $game['id'], ', 1); return false;" method="post">
						<input type="text" id="c', $score['id'], '" name="comment" style="width: 95%;" />
						<input type="submit" value="', $txt['arcade_save'], '" />
					</form>
				</div>';

		}

		echo '
								</td>
							</tr>';
	}

	if (count($context['arcade']['scores']) > 0) // There must be more than zero scores or we will skip them :)
	{
		echo '
							<tr class="titlebg">
								<td colspan="5">', $txt['arcade_highscores'], '</td>
							</tr>
							<tr class="catbg3">
								<td width="5">', $txt['arcade_position'], '</td>
								<td>', $txt['arcade_member'], '</td>
								<td>', $txt['arcade_time'], '</td>
								<td>', $txt['arcade_score'], '</td>
								<td>', $txt['arcade_comment'], '</td>
							</tr>';

		$button['edit'] = create_button('modify.gif', 'arcade_edit', '', 'title="' . $txt['arcade_edit'] . '"');
		$button['delete'] = create_button('delete.gif', 'arcade_delete_score', '', 'title="' . $txt['arcade_delete_score'] . '"');

		foreach ($context['arcade']['scores'] as $score)
		{

			echo '
							<tr class="', $score['own'] ? 'windowbg3' : 'windowbg', '"', $score['highlight'] ? ' style="font-weight: bold;"' : '', '>
								<td class="windowbg2" align="center">', $score['position'], '</td>
								<td>', $score['memberLink'], '</td>
								<td width="300" class="windowbg2">', $score['time'], '</td>
								<td align="center">', $score['score'], '</td>
								<td class="windowbg2">
									<div id="comment', $score['id'], '" style="float: left; ', $score['edit'] && $score['can_edit'] ? 'display: none;' : '', '">', $score['comment'], '</div>';

			if ($score['can_edit']) // Can edit
			{
				echo '
									<div id="edit', $score['id'], '" style="float: left; ', $score['edit'] ? '' : 'display: none;', ' width: 90%;">
										<form action="', $scripturl, '?action=arcade;sa=comment;game=', $game['id'], '" method="post" name="score_edit', $score['id'], '" onsubmit="arcadeCommentEdit(', $score['id'], ', ', $game['id'], '); return false;">
											<input type="hidden" name="score" value="', $score['id'], '" />
											<input type="text" name="comment" id="c', $score['id'], '" value="', $score['raw_comment'], '" style="width: 95%;" />
										</form>
									</div>';
			}


			// Buttons
			if ($score['can_edit'] || $context['arcade']['show_editor'])
			{

				echo '
									<div style="float: right">';

				// Edit
				if ($score['can_edit'])
					echo '
										<a onclick="arcadeCommentEdit(', $score['id'], ', ', $game['id'], ', 0); return false;" href="', $scripturl, '?action=arcade;sa=highscore;game=', $game['id'], ';edit;score=', $score['id'], '">', $button['edit'], '</a>';

				// Delete
				if ($context['arcade']['show_editor'])
					echo '
					<a onclick="return confirm(\'', $txt['arcade_really_delete'], '\');" href="', $scripturl, '?action=arcade;sa=highscore;game=', $game['id'], ';delete;score=', $score['id'], ';sesc=', $context['session_id'], '">', $button['delete'], '</a>';

				echo '
									</div>';


			}


			echo '
								</td>
							</tr>';
		}

		echo '
							<tr class="catbg3">
								<td>', $txt['arcade_position'], '</td>
								<td>', $txt['arcade_member'], '</td>
								<td>', $txt['arcade_time'], '</td>
								<td>', $txt['arcade_score'], '</td>
								<td>', $txt['arcade_comment'], '</td>
							</tr>';
	}

	else
	{
		// No one has played this game

		echo '
							<tr class="windowbg">
								<td align="center" class="catbg3"><b>', $txt['arcade_no_scores'], '</b></td>
							</tr>';
	}

	echo '
						</table>
					</div>';
}

// Below game
function template_ArcadeGame_below()
{
	global $scripturl, $txt, $context, $settings;



	echo '
					<table border="0" cellpadding="0" cellspacing="0" width="100%">
						<tr>
							<td class="middletext">
								', isset($context['arcade']['pageIndex']) ? $txt[139] . ': ' . $context['arcade']['pageIndex'] : '' ,'
							</td>
							<td style="padding-right: 1ex;" align="right">
								<table cellpadding="0" cellspacing="0">
									<tr>
										', template_button_strip($context['arcade']['buttons'], 'top'), '
									</tr>
								</table>
							</td>
						</tr>
					</table>';
}

function template_arcade_statistics()
{
	global $scripturl, $txt, $context, $settings;

	echo '
	<table border="0" cellpadding="0" cellspacing="0" width="100%">
		<tr>
			<td class="middletext"></td>

			<td style="padding-right: 1ex;" align="right">
				<table cellpadding="0" cellspacing="0">
					<tr></tr>
				</table>
			</td>
		</tr>
	</table>

	<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor">
		<tr class="titlebg">
				<td align="center" colspan="4">', $txt['arcade_stats'], '</td>
		</tr>
		<tr>
			<td class="catbg" colspan="2"><b>', $txt['arcade_most_played'], '</b></td>
			<td class="catbg" colspan="2"><b>', $txt['arcade_most_active'], '</b></td>
		</tr>
		<tr>
				<td class="windowbg" width="20" valign="middle" align="center"><img src="', $settings['images_url'], '/gold.gif" alt="" /></td>
				<td class="windowbg2" valign="top">
					<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Most played games
	if (!empty($context['arcade']['statistics']['play']))
	{
		foreach ($context['arcade']['statistics']['play'] as $game)
			echo '
							<tr>
								<td width="60%" valign="top">', $game['link'], '</td>
								<td width="20%" align="left" valign="top">', $game['plays'] > 0 ? '<img src="' . $settings['images_url'] . '/bar.gif" width="' . $game['precent'] . '" height="15" alt="" />' : '&nbsp;', '</td>
								<td width="20%" align="right" valign="top">', $game['plays'], '</td>
							</tr>';
	}

	echo '
					</table>
				</td>

				<td class="windowbg" width="20" valign="middle" align="center"><img src="', $settings['images_url'], '/gold.gif" alt="" /></td>
				<td class="windowbg2" valign="top">
					<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Most active in arcade
	if (!empty($context['arcade']['statistics']['active']))
	{
		foreach ($context['arcade']['statistics']['active'] as $game)
			echo '
							<tr>
								<td width="60%" valign="top">', $game['link'], '</td>
								<td width="20%" align="left" valign="top">', $game['scores'] > 0 ? '<img src="' . $settings['images_url'] . '/bar.gif" width="' . $game['precent'] . '" height="15" alt="" />' : '&nbsp;', '</td>
								<td width="20%" align="right" valign="top">', $game['scores'], '</td>
							</tr>';
	}
	echo '
					</table>
				</td>
		</tr>

		<tr>
			<td class="catbg" colspan="2"><b>', $txt['arcade_best_games'], '</b></td>
			<td class="catbg" colspan="2"><b>', $txt['arcade_best_players'], '</b></td>
		</tr>

		<tr>
				<td class="windowbg" width="20" valign="middle" align="center"><img src="', $settings['images_url'], '/gold.gif" alt="" /></td>
				<td class="windowbg2" valign="top">
					<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Top rated games
	if (!empty($context['arcade']['statistics']['rating']))
	{
		foreach ($context['arcade']['statistics']['rating'] as $game)
			echo '
							<tr>
								<td width="60%" valign="top">', $game['link'], '</td>
								<td width="20%" align="left" valign="top">', $game['rating'] > 0 ? '<img src="' . $settings['images_url'] . '/bar.gif" width="' . $game['precent'] . '" height="15" alt="" />' : '&nbsp;', '</td>
								<td width="20%" align="right" valign="top">', $game['rating'], '</td>
							</tr>';
	}

	echo '
					</table>
				</td>

				<td class="windowbg" width="20" valign="middle" align="center"><img src="', $settings['images_url'], '/gold.gif" alt="" /></td>
				<td class="windowbg2" valign="top">
					<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Best players by champions
	if (!empty($context['arcade']['statistics']['champions']))
	{
		foreach ($context['arcade']['statistics']['champions'] as $game)
			echo '
							<tr>
								<td width="60%" valign="top">', $game['link'], '</td>
								<td width="20%" align="left" valign="top">', $game['champions'] > 0 ? '<img src="' . $settings['images_url'] . '/bar.gif" width="' . $game['precent'] . '" height="15" alt="" />' : '&nbsp;', '</td>
								<td width="20%" align="right" valign="top">', $game['champions'], '</td>
							</tr>';
	}

	echo '
					</table>
				</td>
		</tr>

		<tr>
			<td class="catbg" colspan="4"><b>', $txt['arcade_longest_champions'], '</b></td>
		</tr>
		<tr>
			<td class="windowbg" width="20" valign="middle" align="center"><img src="', $settings['images_url'], '/gold.gif" alt="" /></td>
			<td class="windowbg2" valign="top" colspan="3">
				<table border="0" cellpadding="1" cellspacing="0" width="100%">';

	// Top rated games
	if (!empty($context['arcade']['statistics']['longest']))
	{
		foreach ($context['arcade']['statistics']['longest'] as $game)
			echo '
						<tr>
							<td width="40%" valign="top">', $game['member_link'], ' (', $game['game_link'], ')</td>
							<td width="20%" align="left" valign="top">', $game['duration'] > 0 ? '<img src="' . $settings['images_url'] . '/bar.gif" width="' . $game['precent'] . '" height="15" alt="" />' : '&nbsp;', '</td>
							<td width="40%" align="right" valign="top">', $game['current'] ? '<b>' . $game['duration'] . '</b>' : $game['duration'], '</td>
						</tr>';
	}

	echo '
				</table>
			</td>
		</tr>
	</table>';
}

function template_arcade_below()
{
	global $arcade_version;

	// Print out copyright and version. Removing copyright is not allowed by license
	echo '
	</div>
	<a name="bot"></a>

	<div class="smalltext" style="text-align: center;">
		Powered by: <a href="http://www.smfarcade.info/" target="_blank">SMF Arcade ', $arcade_version, '</a> &copy; <a href="http://www.madjoki.com/" target="_blank">Niko Pahajoki</a> 2004-2009
	</div>';

}

// XML templates
function template_xml() // General XML template
{
	global $context, $txt;

	$extra = isset($context['arcade']['extra']) ? $context['arcade']['extra'] : '';

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
	<smf>
		<txt><![CDATA[', isset($txt[$context['arcade']['message']]) ? $txt[$context['arcade']['message']] : $context['arcade']['message'], ']]></txt>
		', $extra, '
	</smf>';
}

function template_xml_list()
{
	global $context, $txt;

	echo '<', '?xml version="1.0" encoding="', $context['character_set'], '"?', '>
	<smf>';

	foreach ($context['arcade']['search']['games'] as $game)
		echo '
		<game>
			<id>', $game['id'], '</id>
			<name><![CDATA[', $game['name'], ']]></name>
			<url><![CDATA[', $game['url'], ']]></url>
		</game>';

	echo '
		<more>
			<is>', $context['arcade']['search']['more'], '</is>
			<url>', $context['arcade']['search']['more_url'], '</url>
		</more>
	</smf>';
}

?>