<?php
// Version: 2.0.8; ArcadeMenu

function template_arcademenu_above()
{
	global $modSettings;

	echo '
	<table width="100%">
		<tr>';

	if ($modSettings['arcadeGameInformationSide'] == 0)
		echo '
			<td valign="top">', template_arcade_menu() , '</td>';

	echo '
			<td width="80%" valign="top">';
}

function template_arcademenu_below()
{
	global $modSettings;

	echo '
			</td>';

	if ($modSettings['arcadeGameInformationSide'] == 1)
		echo '
			<td valign="top">', template_arcade_menu() , '</td>';

	echo '
		</tr>
	</table>';
}

function template_arcade_menu()
{
	global $modSettings, $context;

	echo '
		<div class="tborder" style="margin-top: 19px;">
			<table class="bordercolor" border="0" cellpadding="4" cellspacing="1" width="100%">';

	$context['arcade']['menu'] = array_reverse($context['arcade']['menu']);

	foreach ($context['arcade']['menu'] as $menu_item)
			$menu_item['template']($menu_item['data']);

	echo '
			</table>
		</div>';

}

function ArcadeMenu_QuickSearch($data)
{
	global $txt, $context, $scripturl;

	echo '
		<tr class="catbg">
			<td align="center">', $txt['arcade_quick_search'], '</td>
		</tr>

		<tr class="windowbg">
			<td align="center">
				<form action="', $scripturl, '?action=arcade" onsubmit="ArcadeQuickSearch(); return false;" method="post">
					<input id="quick_name" type="text" value="" name="name[', rand(0, 1000), ']" onkeyup="ArcadeQuickSearch();" />
				</form>

				<div id="quick_div" class="smalltext">', $txt['arcade_quick_search_help'], '</div>

			</td>
		</tr>';
}

function ArcadeMenu_GameOfDay($game)
{
	global $txt, $context, $scripturl, $settings;

	if ((isset($context['arcade']['game']) && $game['id'] == $context['arcade']['game']['id']) || $game === false) // We wont show this if it's same as game we are playing
		return;

	$ratecode = '';
	$rating = $game['rating'];

	if ($rating > 0)
	{
		$ratecode = str_repeat('<img src="' . $settings['images_url'] . '/star.gif" alt="*" />' , $rating);
		$ratecode .= str_repeat('<img src="' . $settings['images_url'] . '/star2.gif" alt="*" />' , 5 - $rating);
	}

	echo '
		<tr class="catbg">
			<td align="center">', $txt['arcade_game_of_day'], '</td>
		</tr>

		<tr class="windowbg">
			<td align="center">
				', $game['thumbnail'] != '' ? '<div><a href="' . $game['url']['play'] . '"><img src="' . $game['thumbnail'] . '" alt="" /></a></div>' : '', '
				<div><a href="', $game['url']['play'], '">', $game['name'], '</a></div>
			</td>
		</tr>';

	if ($rating > 0)
		echo '
		<tr class="windowbg">
			<td align="center">', $ratecode, '</td>
		</tr>';

	echo '

		<tr class="windowbg">
			<td align="center">';

	if ($game['isChampion'])
		echo '
				<div>
					<strong>', $txt['arcade_champion'], ':</strong> ', $game['champion']['memberLink'], ' - ', $game['champion']['score'], '
				</div>';

	else
		echo $txt['arcade_no_scores'];

	if ($game['isPersonalBest'])
		echo '
				<div>
					<strong>', $txt['arcade_personal_best'], ':</strong> ', $game['personalBest'], '
				</div>';

	echo '
								</td>
							</tr>';

}

function ArcadeMenu_GameInformation($game)
{
	global $txt, $context, $scripturl, $settings;

	$ratecode = '';
	$rating = $context['arcade']['game']['rating'];


	if ($context['arcade']['can_rate'])
	{
		// Can rate

		for ($i = 1; $i <= 5; $i++)
		{
			if ($i <= $rating)
				$ratecode .= '<a href="' . $scripturl . '?action=arcade;sa=rate;game=' . $context['arcade']['game']['id'] . ';rate=' . $i . ';sesc=' . $context['session_id'] . '" onclick="arcade_rate(' . $i . ', ' . $context['arcade']['game']['id'] . '); return false;"><img id="imgrate' . $i . '" src="' . $settings['images_url'] . '/star.gif" alt="*" /></a>';

			else
				$ratecode .= '<a href="' . $scripturl . '?action=arcade;sa=rate;game=' . $context['arcade']['game']['id'] . ';rate=' . $i . ';sesc=' . $context['session_id'] . '" onclick="arcade_rate(' . $i . ', ' . $context['arcade']['game']['id'] . '); return false;"><img id="imgrate' . $i . '" src="' . $settings['images_url'] . '/star2.gif" alt="*" /></a>';
		}
	}
	else
	{
		// Can't rate
		$ratecode = str_repeat('<img src="' . $settings['images_url'] . '/star.gif" alt="*" />' , $rating);
		$ratecode .= str_repeat('<img src="' . $settings['images_url'] . '/star2.gif" alt="*" />' , 5 - $rating);
	}

	echo '
		<tr class="catbg">
			<td align="center">', $txt['arcade_game_info'], '</td>
		</tr>

		<tr class="windowbg">
			<td align="center">
				', $context['arcade']['game']['thumbnail'] != '' ? '<div><img src="' . $context['arcade']['game']['thumbnail'] . '" alt="" /></div>' : '', '
				<div>', $context['arcade']['game']['name'], '</div>
			</td>
		</tr>

		<tr class="windowbg">
			<td align="center">', $ratecode, '</td>
		</tr>

		<tr class="windowbg">
			<td align="center">';

	if ($context['arcade']['game']['isChampion'])
		echo '
				<div>
					<strong>', $txt['arcade_champion'], ':</strong> ', $context['arcade']['game']['champion']['memberLink'], ' - ', $context['arcade']['game']['champion']['score'], '
				</div>';

	else
		echo $txt['arcade_no_scores'];

	if ($context['arcade']['game']['isPersonalBest'])
		echo '
				<div>
					<strong>', $txt['arcade_personal_best'], ':</strong> ', $context['arcade']['game']['personalBest'], '
				</div>';

	echo '
								</td>
							</tr>';
	// Favorite link (if can favorite)
	if ($context['arcade']['can_favorite'])
		echo '
				<tr class="windowbg">
					<td align="center">
						<a href="', $context['arcade']['game']['url']['favorite'], '" onclick="arcade_favorite(', $context['arcade']['game']['id'], '); return false;">', !$context['arcade']['game']['isFavorite'] ?  '<img id="favgame' . $context['arcade']['game']['id'] . '" src="' . $settings['images_url'] . '/favorite.gif" alt="' . $txt['arcade_add_favorites'] . '" />' : '<img id="favgame' . $context['arcade']['game']['id'] . '" src="' . $settings['images_url'] . '/favorite2.gif" alt="' . $txt['arcade_remove_favorite'] .'" />', '</a>
					</td>
				</tr>';

}

?>