<?php
/*******************************************************************************
* SMF Arcade 2.0.12 (http://www.smfarcade.net)                                  *
* Copyright (C) 2004-2007  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* installArcade.php                                                            *
*******************************************************************************/

require_once('SSI.php');
require_once($sourcedir . '/ArcadeInstall.php');

function main()
{
	global $step;

	if (!isset($_GET['step']))
		$step = 0;

	else
		$step = (int) $_GET['step'];

	if (isset($_POST['agree']))
	{
		$_SESSION['agree'] = true;
		$step = 1;

	}

	call_user_func('main_step' . $step);
}

function main_step0()
{
	echo '
	<h2>License agreement</h2>
	<pre>
		', htmlspecialchars( file_get_contents('./ArcadeLicense.txt') ), '
	</pre>
	<form action="installArcade.php" method="post">
		<input type="submit" name="agree" value="I Agree"/>
	</form>';
}

function main_step1()
{
	global $step;

	echo '
	<h2>Select install type</h2>

	<div class="installs">
		<a href="?step=2"><b>New install</b></a>
		Select this if you are installing first  or want to lose old data. <span stimetyle="color: red">This may cause loss of data.</span>
		<a href="?step=3;full"><b>Full update</b></a>
		Updates and does full table update, don\'t use this if you have installed mods that edits tables of SMF Arcade since you will lose them.
		<a href="?step=3"><b>Update</b></a>
		Select this if you are updating from any 2.0.x version to new.
		<a href="?step=4"><b>Import</b></a>
		Select this if you are installing first time and want to import existing data from 1.3.0. <span style="color: red">Use this on a clean install of SMF Arcade 2.0.0 for best results.</span>
	</div>';
}

function main_step2()
{
	global $ArcadeSettings, $Permissions, $Tables, $scripturl;

	echo '
	<h2>SMF Arcade Installer</h2>
	<h3>Creating tables</h3>';

	// Tables

	$errors = CreateTables($Tables);

	if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means something went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	echo '
	<h3>Inserting default permissions</h3>';

   // Permissions

   $errors = ResetPermissions($Permissions);

   if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means something went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	// Settings

	echo '
	<h3>Inserting default settings</h3>';

   $errors = ResetSettings($ArcadeSettings);

   if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means something went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	echo '
	<h3>Finishing</h3>';

	$errors = PopulateTables();

	if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means something went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	echo '
	<div>SMF Arcade Installer complete</div>';

	echo '
	<div>
		<a href="', $scripturl, '?action=managegames">Continue to Arcade Administration</a>
	</div>';
}

function main_step3()
{
	 global $Tables, $ArcadeSettings, $scripturl;

	 echo '
	 <h2>Updating</h2>';

	 echo isset($_REQUEST['full']) ? '<h3>Full update</h3>' : '';

	 $errors = ResetSettings($ArcadeSettings, true);

	 if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';


	if (isset($_REQUEST['full']))
		$errors = UpdateTables($Tables, true);
	else
		$errors = UpdateTables($Tables, false);

	if ($errors === false)
		echo '
		<div>All Tables were up to date already</div>';
	else
	{
		echo '
		<div>Tables have been updated!</div>';

		if (is_array($errors) && count($errors) > 0)
			echo '
			<h3 style="color: red;">Error report! (This means somehing went wrong)</h3>
			<div>', implode('<br />', $errors), '</div>';
	}

	echo '
	<div>
		<a href="', $scripturl, '?action=managegames">Continue to Arcade Administration</a>
	</div>';

}

function main_step4()
{
	echo '
	 <h2>Importing games and scores</h2>';

	 $errors = ImportGames();

	if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';
}

echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset="ISO-8859-1" />
		<title>SMF Arcade ', $version ,' Installer</title>
		<script language="JavaScript" type="text/javascript" src="Themes/default/script.js"></script>
		<link rel="stylesheet" type="text/css" href="Themes/default/style.css?rc2" />
		<style type="text/css">
			body
			{
				background-color: #E5E5E8;
				margin: 0px;
				padding: 0px;
			}
			body, td
			{
				color: #000000;
				font-size: small;
				font-family: verdana, sans-serif;
			}
			div#header
			{
				background-image: url(Themes/default/images/catbg.jpg);
				background-repeat: repeat-x;
				background-color: #88A6C0;
				padding: 22px 4% 12px 4%;
				color: white;
				font-family: Georgia, serif;
				font-size: xx-large;
				border-bottom: 1px solid black;
				height: 40px;
			}
			div#content
			{
				padding: 20px 30px;
			}
			div.error_message
			{
				border: 2px dashed red;
				background-color: #E1E1E1;
				margin: 1ex 4ex;
				padding: 1.5ex;
			}
			div.panel
			{
				border: 1px solid gray;
				background-color: #F6F6F6;
				margin: 1ex 0;
				padding: 1.2ex;
			}
			div.panel h2
			{
				margin: 0;
				margin-bottom: 0.5ex;
				padding-bottom: 3px;
				border-bottom: 1px dashed black;
				font-size: 14pt;
				font-weight: normal;
			}
			div.panel h3
			{
				margin: 0;
				margin-bottom: 2ex;
				font-size: 10pt;
				font-weight: normal;
			}
			.installs a
			{
				display: block;
				border-bottom: 1px dashed black;
			}
			form
			{
				margin: 0;
			}
			td.textbox
			{
				padding-top: 2px;
				font-weight: bold;
				white-space: nowrap;
				padding-left: 2ex;
			}
		</style>
	</head>
	<body>
		<div id="header">
		SMF Arcade ', $version, '
		</div>

		<div id="content">
			<div>
				', main(), '
			</div>

			<div style="margin-top: 10px;">
				<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
					<input type="hidden" name="cmd" value="_xclick">
					<input type="hidden" name="business" value="niko.pahajoki@gmail.com">
					<input type="hidden" name="no_shipping" value="2">
					<input type="hidden" name="no_note" value="1">
					<input type="hidden" name="currency_code" value="USD">
					<input type="hidden" name="tax" value="0">
					<input type="hidden" name="bn" value="PP-DonationsBF">
					<input type="image" src="https://www.paypal.com/en_US/i/btn/x-click-but04.gif" border="0" name="submit" alt="Make payments with PayPal - it\'s fast, free and secure!">
					<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
				</form>
			</div>
		</div>
	  </body>
</html>';

?>