<?php
/*******************************************************************************
* SMF Arcade 2.0.12 (http://www.smfarcade.net)                                  *
* Copyright (C) 2004-2006  Niko Pahajoki (http://www.madjoki.com)              *
* This program is free software; you can redistribute it and/or modify         *
* it under the terms of the GNU General Public License as published by         *
* the Free Software Foundation; either version 2 of the License, or            *
* (at your option) any later version.                                          *
*                                                                              *
* This program is distributed in the hope that it will be useful,              *
* but WITHOUT ANY WARRANTY; without even the implied warranty of               *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
* GNU General Public License for more details.                                 *
*                                                                              *
* You should have received a copy of the GNU General Public License            *
* along with this program; if not, write to the Free Software                  *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA *
********************************************************************************
* package_install.php                                                          *
********************************************************************************/

global $boardurl, $sourcedir, $modSettings;
global $Tables, $ArcadeSettings, $Permissions;

require_once($sourcedir . '/ArcadeInstall.php');


echo '
<div class="tborder" style="margin: 25px;">
	<div class="titlebg" style="padding: 1ex;">
		<b>SMF Arcade 2.0.0 Installer</b>
	</div>
	<div class="windowbg">';

if (!empty($modSettings['arcadeDatabaseVersion']))
{

	 echo '
	 <h2>Updating</h2>';
	 
	 $errors = ResetSettings($ArcadeSettings, true);
	 
	 if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';
	 
	 $errors = UpdateTables($Tables);
	 
	 if ($errors === false)
		echo '
		<div>All Tables were up to date already</div>';
	 else
	 {
		echo '
		<div>Tables have been updated!</div>';
		
		if (is_array($errors) && count($errors) > 0)
			echo '
			<h3 style="color: red;">Error report! (This means somehing went wrong)</h3>
			<div>', implode('<br />', $errors), '</div>'; 
	 }
}
else 
{
   
	echo '
	<h3>Creating tables</h3>';
	
	// Tables
	
	$errors = CreateTables($Tables);
	
	if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	echo '
	<h3>Inserting default permissions</h3>';
	
   // Permissions
				
   $errors = ResetPermissions($Permissions);
   
   if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	// Settings
	
	echo '
	<h3>Inserting default settings</h3>';
		
   $errors = ResetSettings($ArcadeSettings); 
   
   if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';

	echo '
	<h3>Finishing</h3>';
	
	$errors = PopulateTables();
	
	if (count($errors) > 0)
		echo '
		<h4 style="color: red;">Error report! (This means somehing went wrong)</h4>
		<div>', implode('<br />', $errors), '</div>';
	else
		echo '
		<div>Success with no errors!</div>';
		

	if (!is_dir($ArcadeSettings['gamesDirectory'][0])) 
	{
		if (mkdir($ArcadeSettings['gamesDirectory'][0], 0755))
			echo '<div>Games directory created</div>';
		else
			echo '<div style="color: red;">Games directory does not exist, and make dir failed, probably because of safemode</div>';
	}
}


echo '
		<div>Package was installed. If you have SMFArcade 1.x installed you can <a href="installArcade.php?step=4">import games and scores now</a></div>
	</div>
</div>';

?>